package com.application.particles.flow;

import java.util.HashMap;
import java.util.Map;

public enum Outcode {
	
	INSIDE("inside", -1),
	OUTLEFT("Left", 0),
	OUTRIGHT("Right", 1),
	OUTTOP("Top", 2),
	OUTBOTTOM("Bottom", 3),
	OUTFRONT("Front", 4),
	OUTREAR("Rear", 5) ; 
	
	private final String key; 
	
	private final int position ; 
	

	private static final Map<String, Outcode> outMap ; 
	
	static {
		outMap = new HashMap<String, Outcode>()  ;
		for(Outcode outcode : values()){
			outMap.put(outcode.getKey(), outcode) ; 
		}
		
	}
	public String getKey() {
		return this.key;
	}
	
	public int getPosition() {
		return position;
	}



	private Outcode(String key, int position){
		this.key = key ; 
		this.position = position ; 
	}

	public static Outcode getByKey(String outKey){
		return outMap.get(outKey) ; 
	}
	
}
