package com.application.particles.flow;

import java.awt.*;

import javax.swing.*;
import javax.media.opengl.GL;
import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.GLProfile;
import javax.media.opengl.awt.GLCanvas;
import javax.media.opengl.fixedfunc.GLMatrixFunc;
import javax.media.opengl.glu.GLU;

import ar.ARNode;
import ar.ARNodeBlock;
import ar.ARSparseStorage;
import ar.ARStorage;
import ar.ARStorageBlock;

import com.jogamp.opengl.util.FPSAnimator;
import static javax.media.opengl.fixedfunc.GLLightingFunc.GL_COLOR_MATERIAL;
import static javax.media.opengl.fixedfunc.GLLightingFunc.GL_LIGHT0;
import static javax.media.opengl.fixedfunc.GLLightingFunc.GL_LIGHTING;
import static javax.media.opengl.fixedfunc.GLMatrixFunc.GL_PROJECTION;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import com.application.basic.ParticleARNode;
import com.application.basic.Point3D;
import com.application.basic.Vector;
import javax.swing.event.*;
import javax.vecmath.Point3f;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Random;
import edu.unh.sdb.common.*;
import edu.unh.sdb.datasource.*;

/**
 * 
 * FLOW VISUALIZATION TOOL
 * 
 * This Java Program visualizes - Vectors in the frame. - Flow of 3D particles
 * (3D Blob) in the vector field. - 3D Particles generate at random positions
 * and they start flowing in the vector field. - Flow of 3D particles both in 2D
 * and 3D vector field is implemented
 * 
 * GUI_PANEL : An user interaction panel with 3 sub panels. FLOW_PANEL: - No of
 * particles - No of Streamlets/ 3D Blob - Life time of particle - No of frames
 * / second - 2D Flow or 3D Flow selection
 * 
 * VIEW_PANEL: - ViewPort parameters - Vector Scale - 3D Cylinder parameter
 * adjustments
 * 
 * DATASOURCE_PANEL: - Chunk lower and upper bounds adjustment - Chunk Slice -
 * Chunk Volume
 * 
 * @author AbinayaPitchai
 * 
 */
public class ParticlesFlow extends JFrame implements GLEventListener {

	// JPanel Variables
	private static JFrame cp = new JFrame("FLOW PARAMETERS CONTROL PANEL");
	private static JSlider slider;
	private static JSlider slider2;
	private static JSlider slider3;
	private static JSlider slider4;
	private static JCheckBox check;
	private static JCheckBox check1;
	private static JCheckBox check2;
	private static JCheckBox check3;
	private static JCheckBox check4;
	static JCheckBox mrView;
	static JCheckBox arView;
	private static JCheckBox changeRS;
	private static JCheckBox showError;

	private static JSpinner spinner_width;
	private static JSpinner spinner_height;

	public static int chunkSizeOfX;
	public static int chunkSizeOfY;
	public static int chunkSizeOfZ;
	public static boolean animating = true;
	public static int viewport_width;
	public static int viewport_height;
	public static int vscale;
	public static int lowChunkX, lowChunkY, lowChunkZ, upChunkX, upChunkY,
			upChunkZ, slice;

	private static HashMap<String, Vector> myVec = new HashMap<String, Vector>();
	static float[] valsMain_x = null;
	static float[] valsMain_y = null;
	private int yi = 1;
	int s = 0;
	int s1 = 0;

	// Main Function Variables

	public static int parCt;
	public static Streamlet streamlets[];
	public static Streamlet particles2[];
	public static Streamlet particles3[];
	public static int lifeTime[];
	public static int countPart;
	public static int countStreamLet;
	public static int age;
	public static int sl;
	public static float bRadius;
	public static float tRadius;
	public static float height;
	public static int slices;
	public static int stacks;
	public static int dsRes = 0;
	public static int errRes = 1;

	public static ArrayList<Streamlet> visibleList;
	public static ArrayList<Streamlet> invisbleList;
	public static float arrX[] = new float[1024];
	public static float arrY[] = new float[1024];

	public static int visibleCt;
	public static int invisibleCt;
	int init = 0;
	private static float red = 1.0f;
	private static float blue = 1.0f;
	private static float green = 1.0f;
	public static GLCanvas canvas;
	public static FPSAnimator animator;
	public static Random rand = new Random(65756);
	public static DataBlock arSubBlock_x = null;
	public static DataBlock arSubBlock_y = null;
	public static boolean arViewParticlesFlow = false;

	private static String mainFile1 = "TornadoData/tornado-vx/tornado-vx.xfdl";
	private static String mainFile2 = "TornadoData/tornado-vy/tornado-vy.xfdl";
	private static String mainFile3 = "TornadoData/tornado-vz/tornado-vz.xfdl";

	public static DataSource ds1 = null; // the original data source
	public static DataSource ds2 = null;
	public static DataSource ds3 = null;
	public static DataSource dsHelix = null;
	public static DataBlock block_DS1 = null;
	public static DataBlock block_DS2 = null;
	public static DataBlock block_DS3 = null;
	public static DataSource errDSx[] = null;
	public static DataSource errDSy[] = null;
	public static DataSource errDSz[] = null;

	public static DataBlock errBlock_x = null;
	public static DataBlock errBlock_y = null;
	public static DataBlock errBlock_z = null;

	public static DataBlock dbHelix = null;

	public static ARSparseStorage[] arStorage = new ARSparseStorage[3];
	
	public static ARSparseDataSource[] arSparseDS = new ARSparseDataSource[3] ;

	public ParticleARNode particleARRoot_x;

	// ----gluLookat parameters -------
	float eyeX, eyeY, eyeZ; // gluLookat eye position
	float lookX, lookY, lookZ; // gluLookat look position
	float upX, upY, upZ; // up vector

	private int winx;
	private int winy;

	static int preRes = 0;
	// FORMAT : LEFT , RIGHT, TOP, BOTTOM, FRONT, BACK
	Integer[][] childrenArr = { { -1, 1, 2, -1, -1, 4 }, // 0 :: (0, 0, 0) =>
															// (63, 63, 63)
			{ 0, -1, 3, -1, -1, 5 }, // 1 :: (63, 0, 0) => (127, 63, 63)
			{ -1, 5, -1, 0, -1, 6 }, // 2 :: (0, 63, 0) => (63, 127, 63)
			{ 2, -1, -1, 1, -1, 7 }, // 3 :: (63, 63, 0) => (127, 127, 63)
			{ -1, 4, 6, -1, 0, -1 }, // 4 :: (0, 0, 63) => (63, 63, 127)
			{ 4, -1, 7, -1, 1, -1 }, // 5 :: (63, 0, 63) => (127, 63, 127)
			{ -1, 7, -1, 4, 2, -1 }, // 6 :: (0, 63, 63) => (63, 127, 127)
			{ 6, -1, -1, 5, 3, -1 } // 7 :: (63, 63, 63) => (127, 127, 127)
	};
	

	public ParticlesFlow() {
		winx = winy = 1200;
		parCt = 1000;
		lifeTime = new int[parCt];
		streamlets = new Streamlet[parCt];
		countPart = 100;
		countStreamLet = 2;
		age = 30;
		viewport_height = 1200;
		viewport_width = 1200;
		vscale = 600;
		// lowChunkX = 70; lowChunkY = 16; lowChunkZ = 21;
		// upChunkX = 110; upChunkY = 55; upChunkZ = 30;

		lowChunkX = 0;
		lowChunkY = 0;
		lowChunkZ = 0;
		upChunkX = 31;
		upChunkY = 31;
		upChunkZ = 31;

		slice = 4;
		chunkSizeOfX = 50;
		chunkSizeOfY = 50;
		chunkSizeOfZ = 50;

		GLProfile glp = GLProfile.getDefault();
		GLCapabilities caps = new GLCapabilities(glp);
		canvas = new GLCanvas(caps);

		Frame frame = new Frame("JOGL Flow Test");
		// frame.setSize( 640 , 480 );
		frame.setSize(winx, winy);
		frame.add(canvas);
		frame.setVisible(true);
		visibleList = new ArrayList<Streamlet>();

		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

		Log.init("Granite-errors", Log.LogToFile | Log.LogToStdErr);
		SDBError.setErrorReportingLevel(SDBError.AlwaysThrow);
		openAndActivateDatasources();

		buildJPanel(cp.getContentPane());

		generateARStorageData();

		chunkSizeOfX = arStorage[0].getDsArr(dsRes).getBounds().getUpper(0);
		chunkSizeOfY = arStorage[0].getDsArr(dsRes).getBounds().getUpper(1);
		chunkSizeOfZ = arStorage[0].getDsArr(dsRes).getBounds().getUpper(2);

		// Setting the initial position of particles randomly
		setParticlesInitialData();

		// generating the error data sources
		generateErrorData();

		visibleCt = parCt;
		for (int y = 0; y < visibleCt; y++) {
			visibleList.add(streamlets[y]);
		}

		// creatErrorBlocks();
		// PERFORMANCE TEST : adding particles to the first level of root node
//		
		
		
		particleARRoot_x = new ParticleARNode();
		particleARRoot_x.getVisibleParticles().addAll(visibleList);
		ARNode root_x = arStorage[0].getArDataSource().getRoot();
		particleARRoot_x.setNodeBounds(root_x.getBounds());
		particleARRoot_x.setId("parent");
		addParticlesInFirstLevelOfARTree(root_x);
		//addRegionNodes() ; 

		// Calling the animator
		animator = new FPSAnimator(canvas, 40);
		animator.add(canvas);
		animator.start();

	}

	public static void main(String[] args) {
		ParticlesFlow ft = new ParticlesFlow();
		canvas.addGLEventListener(ft);
	}

	public class MyChangeAction implements ChangeListener {
		public void stateChanged(ChangeEvent ce) {
			animator.stop();
			animator.remove(canvas);
			animator = new FPSAnimator(canvas, sl);
			animator.add(canvas);
			animator.start();
		}
	}

	public void dispose(GLAutoDrawable drawable) {
	}

	public void displayChanged(GLAutoDrawable drawable) {
	}

	@Override
	public void init(GLAutoDrawable drawable) {
		appInit(drawable.getGL().getGL2());
	}

	@Override
	public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
		GL2 gl = drawable.getGL().getGL2();
		gl.glViewport(0, 0, w, h);
	}

	public void display(GLAutoDrawable drawable) {

		if (mrView.isSelected() && arView.isSelected() == false) {
			createDataBlock(dsRes);
			arViewParticlesFlow = false;
		}

		if (arView.isSelected() == true) {
			mrView.setSelected(false);
			for (int a = 0; a < 3; a++) {
				if (arStorage[a].isTableCreated() == false) {
					// System.out.println("Generating the AR Hash table for axis data "
					// + a + " ...") ;
					arStorage[a].createARDataBlocksAndAddToARTable();
				}
			}
		}
		// initial settings

		GL2 gl = drawable.getGL().getGL2();
		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		gl.glLoadIdentity();

		/*
		 * glLookAt parameters
		 */
		GLU glu = new GLU();
		// glu.gluLookAt(1, 1, 1, 1, 1, -1, 1, 1, 0 );
		glu.gluLookAt(0, 0, 0, 0, 0, -1, 0, 1, 0);

		/*
		 * PROJECTION PARAMETERS
		 */
		gl.glMatrixMode(GL_PROJECTION);
		gl.glLoadIdentity();

		// gl.glOrtho(-10, 64, -10, 64 ,-10, 64);
		// gl.glOrtho(0, 100, 0, 100 , 0, 100);
		// gl.glOrtho(-10, 70, -10, 70 ,-10, 70);
		// gl.glOrtho(-500, 700, -500, 700, -500, 700);
		gl.glOrtho(0, 1200, 0, 1200, 0, 1200);
		// glu.gluPerspective(300, 1.0, -1200, 1200);

		/*
		 * MODELLING TRANSFORMATION
		 */
		gl.glMatrixMode(GL2.GL_MODELVIEW);
		// gl.glScalef(2.0f, 2.0f, 2.0f) ;
		// gl.glRotatef(45.f, 0, 1, 0) ;

		/*
		 * VIEWING TRANSFORMATION
		 */
		gl.glViewport(0, 0, viewport_width, viewport_height);

		/*
		 * LIGHT AND MATERIAL SETTINGS
		 */
		// appInit(drawable.getGL().getGL2());

		/*
		 * BACKGND COLOR
		 */
		if (check3.isSelected()) {
			gl.glClearColor(1.0f, 1.0f, 1.0f, 1.0f); // white
		}
		gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f); // black

		/*
		 * ANIMATION
		 */
		if (check4.isSelected()) {
			animating = false;
		} else if (!check4.isSelected()) {
			animating = true;
		}

		/*
		 * FOR NOW IF AR VIEW SELECTED THE RES IS 0, BECOZ THE CURRENT AR TREE
		 * LEAVES HAVE DATA AT 0 RES
		 */
		if (arView.isSelected()) {
			dsRes = 0;
		}

		/*
		 * SETTING THE CHUNK SIZE BASED ON THE RESOLUTION DATA BOUNDS
		 */
		chunkSizeOfX = arStorage[0].getDsArr(dsRes).getBounds().getUpper(0) + 1;
		chunkSizeOfY = arStorage[0].getDsArr(dsRes).getBounds().getUpper(1) + 1;
		chunkSizeOfZ = arStorage[0].getDsArr(dsRes).getBounds().getUpper(2) + 1;

		/*
		 * SETTINGS THE PARTICLES INITIAL DATA WHEN VIEW CHANGES
		 */
		if (changeRS.isSelected()
				|| (arView.isSelected() && arViewParticlesFlow == false)) {

			setParticlesInitialData();
			changeRS.setSelected(false);
			arViewParticlesFlow = true;
		}

		/*
		 * DISPLAY OF VECTORS, PARTICLES AND ERROR
		 */
		showVectors(gl);
		setParticlesLifeTime();
		showParticlesFlow(gl);

		/*
		 * UPDATING THE PARTICLES LIST
		 */
	//	updateParticlesInFirstLevelOfARTree();

		if (showError.isSelected()) {
			creatErrorBlocks();
			showErrorDisplay(gl);
		}

		/*
		 * PERFORMANCE TEST
		 */

		gl.glDisable(GL_COLOR_MATERIAL);
		gl.glDisable(GL_LIGHTING);
		gl.glDisable(GL_LIGHT0);
	}

	private void setParticlesLifeTime() {
		// Particles Lifetime
		visibleList.get(0).alive = true;
		if (yi < countPart) {
			visibleList.get(yi).alive = true;
		}
		for (int x = 0; x < countPart; x++) {
			if ((lifeTime[x] < age) && (visibleList.get(x).alive == true)) {
				lifeTime[x]++;
			} else if (Float.isNaN(visibleList.get(x).xval)
					|| Float.isNaN(visibleList.get(x).yval)) {
				visibleList.get(x).xval = visibleList.get(x).initx;
				visibleList.get(x).yval = visibleList.get(x).inity;
				lifeTime[x] = 0;
			} else {
				visibleList.get(x).xval = visibleList.get(x).initx;
				visibleList.get(x).yval = visibleList.get(x).inity;
				lifeTime[x] = 0;
			}
		}
		yi++;
	}

	private void showVectors(GL2 gl) {

		 System.out.println(" Drawing the vectors... " ) ;
		int y_incrementor = getVectorDisplayIncrementor(chunkSizeOfY);
		int x_incrementor = getVectorDisplayIncrementor(chunkSizeOfX);

		// for(int zslice = 0 ; zslice < chunkSize; zslice ++ ){
		for (int y = 0; y < chunkSizeOfY; y = y + y_incrementor) {
			for (int x = 0; x < chunkSizeOfX; x = x + x_incrementor) {
				if (check.isSelected()) {
					// System.out.println("x, y : " + x + ", " + y);
					drawVectors(gl, x, y, slice, 1.0f);
				}
			}
		}
		// }
	}

	/**
	 * For avoiding the clustered display of vectors
	 */
	private int getVectorDisplayIncrementor(int size) {

		// Method 1 : incrementor value based on the bounds.
		int incrementor = 1;
		// if (size <= 128) {
		// incrementor = 4;
		// } else {
		// incrementor = 8;
		// }

		// Method 2: incrementor value based on the window resolution
		// Let every 3 x 3 space have a vector
		int space = 20;
		int tot_vecs = winx / space;

		incrementor = size / tot_vecs;

		return incrementor;
	}

	private void showParticlesFlow(GL2 gl) {

		 System.out.println(" Drawing the particles... " ) ;
		// Particles
		for (int y = 0; y < countPart; y++) {
			if (visibleList.get(y).alive == true) {
				visibleList.get(y).drawParticles(gl, 1.0f, myVec,
						visibleList.get(y).streamletObjectNum, countStreamLet,
						check1.isSelected(), check2.isSelected(),
						check4.isSelected());
				if (visibleList.get(y).streamletObjectNum < (countStreamLet - 1)) {
					visibleList.get(y).streamletObjectNum = visibleList.get(y).streamletObjectNum + 1;
				} else {
					visibleList.get(y).streamletObjectNum = 0;
				}
			}
		}
	}

	/**
	 * Method to draw vectors
	 */
	public void drawVectors(GL gl, int x, int y, int z, float vecScale) {

		// Din't handle the dscale , vscale operation yet.
		float dScale = 1.0f;
		float x1 = x * dScale;
		float y1 = y * dScale;
		float[] color1 = new float[3];
		float[] color2 = new float[3];
		Point3D deltaVec = new Point3D(0.0f, 0.0f, 0.0f);

		if (mrView.isSelected()) {
			// arView.setSelected(false);
			color1[0] = 1.0f;
			color1[1] = color1[2] = 0.0f;
			color2[0] = color2[1] = 1.0f;
			color2[2] = 0.0f;
			deltaVec.sx = (getPosValueInDataSource(block_DS1, x, y, z) * -10);
			deltaVec.sy = (getPosValueInDataSource(block_DS2, x, y, z) * -10);
		}

		if (arView.isSelected()) {
			color1[0] = 0.8f;
			color1[1] = 1.0f;
			color1[2] = 0.3f;
			color2[0] = 0.2f;
			color2[1] = 0.2f;
			color2[2] = 0.7f;
			IntegerIndexSpaceID id = new IntegerIndexSpaceID(z, y, x);
			// getPosValueInARDatasource(id, 0, deltaVec) ;
			deltaVec = getPosValueInARDatasource(id, 0);
			deltaVec.sx *= -10;
			deltaVec.sy *= -10;
			deltaVec.sz *= -10;
		}

		int mul = getScalingValue();

		((GL2) gl).glColor3f(color1[0], color1[1], color1[2]);
		((GL2) gl).glBegin(GL.GL_LINES);
		((GL2) gl).glVertex2f((float) x1 * mul, (float) y1 * mul);
		((GL2) gl).glColor3f(color2[0], color2[1], color2[2]);
		((GL2) gl).glVertex2f((float) (x1 + deltaVec.sx) * mul,
				(float) (y1 + deltaVec.sy) * mul);

		((GL2) gl).glEnd();
	}

	/*--------------------------------- */
	private void appInit(GL2 gl) {

		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
		gl.glClearDepth(5.0); // sets farthest z-value
		gl.glEnable(GL2.GL_DEPTH_TEST); // Enable depth testing
		gl.glShadeModel(GL2.GL_SMOOTH); // Enable smooth shading

		// Set material properties.
		float[] matAmbient = { 0.7f, 0.7f, 0.7f, 1.0f };
		float[] matDiffuse = { 0.8f, 0.8f, 0.8f, 1.0f };
		float[] matSpecular = { 1.0f, 1.0f, 1.0f, 1.0f };
		float[] highShininess = { 50.0f };

		gl.glMaterialfv(GL2.GL_FRONT, GL2.GL_AMBIENT, matAmbient, 0);
		gl.glMaterialfv(GL2.GL_FRONT, GL2.GL_DIFFUSE, matDiffuse, 0);
		gl.glMaterialfv(GL2.GL_FRONT, GL2.GL_SPECULAR, matSpecular, 0);
		gl.glMaterialfv(GL2.GL_FRONT, GL2.GL_SHININESS, highShininess, 0);

		// Prepare light parameters.
		float lightAmbient[] = { 0.2f, 0.2f, 0.2f, 1.0f };
		float lightDiffuse[] = { 0.6f, 0.6f, 0.6f, 1.0f };
		float lightSpecular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		float lightPosition[] = { 30.0f, 30.0f, 0.0f };

		gl.glEnable(GL2.GL_LIGHT0);
		gl.glEnable(GL2.GL_NORMALIZE);
		gl.glEnable(GL2.GL_COLOR_MATERIAL);
		gl.glEnable(GL2.GL_LIGHTING);

		// Set light parameters.
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_AMBIENT, lightAmbient, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_DIFFUSE, lightDiffuse, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_SPECULAR, lightSpecular, 0);
		gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_POSITION, lightPosition, 0);

		// Initialize Cylinder (Streamlet) params
		// bRadius = (float) (0.7f * 18.5) ;
		// tRadius = (float) (0.7f * 18.5);
		// height = (float) (7.0f * 18.5);
		// slices = (50 * 19);
		// stacks = (50 * 19);

		bRadius = 2.0f;
		tRadius = 2.0f;
		height = 6.0f;
		slices = stacks = 60;
	}

	// -------------------------------- Creating the JPanel properties
	// -----------------------------------------------------

	private static void buildJPanel(Container pane) {
		JTabbedPane tabbedPane = new JTabbedPane();

		cp.setLayout(new GridLayout());
		tabbedPane.add("FLOW_PANEL", getFlowPanel());
		tabbedPane.add("VIEW_PANEL", getViewPanel());
		tabbedPane.add("DATASOURCE_PANEL", getDataSourcePanel());
		tabbedPane.add("MR_PANEL", getMRSourcePanel());
		pane.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		pane.add(tabbedPane, BorderLayout.CENTER);
		// cp.add(panel , BorderLayout.CENTER);
		cp.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		cp.setLocation(900, 500);
		cp.setSize(500, 500);
		cp.setVisible(true);

	}

	private static JPanel getFlowPanel() {

		JPanel panel1 = new JPanel(new FlowLayout());

		// slider 1 : No of Particles

		slider = new JSlider(JSlider.HORIZONTAL, 0, 1000, 10);
		slider.setBorder(BorderFactory.createTitledBorder("NO OF PARTICLES"));
		slider.setMajorTickSpacing(200);
		slider.setValue(countPart);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.setLabelTable(slider.createStandardLabels(200));
		slider.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				countPart = (Integer) ((JSlider) e.getSource()).getValue();
			}
		});
		panel1.add(slider);

		// slider2 : No of StreamLets

		slider2 = new JSlider(JSlider.HORIZONTAL, 1, 10, 1);
		// Border b = BorderFactory.createLineBorder( Color.black, 1 );
		slider2.setBorder(BorderFactory.createTitledBorder("NO OF STREAMLETS"));
		slider2.setMajorTickSpacing(1);
		slider2.setPaintTicks(true);
		slider2.setPaintLabels(true);
		slider2.setValue(4);
		slider2.setLabelTable(slider2.createStandardLabels(1));
		slider2.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				countStreamLet = (Integer) ((JSlider) e.getSource()).getValue();
			}
		});
		panel1.add(slider2);

		// slider3 : LifeTime of Particles

		slider3 = new JSlider(JSlider.HORIZONTAL, 0, 500, 400);
		// Border b = BorderFactory.createLineBorder( Color.black, 1 );
		slider3.setBorder(BorderFactory
				.createTitledBorder("PARTICLES LIFETIME"));
		slider3.setMajorTickSpacing(100);
		slider3.setPaintTicks(true);
		slider3.setPaintLabels(true);
		slider3.setValue(30);
		slider3.setLabelTable(slider3.createStandardLabels(100));
		slider3.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				age = (Integer) ((JSlider) e.getSource()).getValue();
			}
		});
		panel1.add(slider3);

		// slider4 : Frames per second
		slider4 = new JSlider(JSlider.HORIZONTAL, 0, 50, 10);
		// Border b = BorderFactory.createLineBorder( Color.black, 1 );
		slider4.setBorder(BorderFactory.createTitledBorder("FRAMES PER SECOND"));
		slider4.setMajorTickSpacing(10);
		slider4.setPaintTicks(true);
		slider4.setPaintLabels(true);
		slider4.setValue(7);
		slider4.setLabelTable(slider4.createStandardLabels(10));
		slider4.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				sl = (Integer) ((JSlider) e.getSource()).getValue();
			}
		});

		panel1.add(slider4);

		// Check boxes
		check = new JCheckBox("SHOW FIELD");
		check.setActionCommand("SHOW FIELD");
		check.setBorder(BorderFactory.createTitledBorder("SHOW FIELD"));
		check.setSelected(true);

		panel1.add(check);

		check1 = new JCheckBox("SHOW 2DFLOW");
		check1.setActionCommand("SHOW 2DFLOW");
		check1.setBounds(60, 400, 220, 30);
		// check1.setBorder(BorderFactory.createTitledBorder("SHOW 2DFLOW")) ;
		check1.setSelected(false);
		panel1.add(check1);

		check2 = new JCheckBox("SHOW 3DFLOW");
		check2.setActionCommand("SHOW 3DFLOW");
		// check2.setBorder(BorderFactory.createTitledBorder("SHOW 3DFLOW")) ;
		check2.setSelected(true);
		panel1.add(check2);

		check3 = new JCheckBox("Change BG Color");
		check3.setActionCommand("SHOW 3DFLOW");
		// check2.setBorder(BorderFactory.createTitledBorder("SHOW 3DFLOW")) ;
		check3.setSelected(false);
		panel1.add(check3);

		check4 = new JCheckBox("Stop animation");
		check4.setActionCommand("STOP FLOW");
		// check2.setBorder(BorderFactory.createTitledBorder("SHOW 3DFLOW")) ;
		check4.setSelected(false);
		panel1.add(check4);

		return panel1;
	}

	// Granite function -> 11/6/13
	private static DataSource openDataSource(String dsName, String fileName) {
		DataSource ds = null;
		try {
			ds = DataSource.create(dsName, fileName);
		} catch (Exception ex) {
			System.err.println("Open error: " + ex.getMessage());
			System.exit(-1);
		}
		return ds;
	}

	private static JPanel getViewPanel() {

		JPanel panel2 = new JPanel(new GridLayout(5, 1));
		// view port transformation

		panel2.add(new JLabel("ViewPort Width"));
		SpinnerModel spinnerModel1 = new SpinnerNumberModel(800, 100, 1000, 100);
		spinner_width = new JSpinner(spinnerModel1);
		// spinner_width.setBorder(
		// BorderFactory.createTitledBorder("VIEWPORT TRANSFORMATION") );
		spinner_width.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				viewport_width = (Integer) ((JSpinner) e.getSource())
						.getValue();
			}
		});
		panel2.add(spinner_width);

		panel2.add(new JLabel("ViewPort Height"));
		SpinnerModel spinnerModel2 = new SpinnerNumberModel(800, 100, 1000, 100);
		spinner_height = new JSpinner(spinnerModel2);
		spinner_height.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				viewport_height = (Integer) ((JSpinner) e.getSource())
						.getValue();
			}
		});
		panel2.add(spinner_height);

		panel2.add(new JLabel("Vector Scale"));
		SpinnerModel spinnerModel3 = new SpinnerNumberModel(500, 100, 1000, 100);
		JSpinner spinner_vscale = new JSpinner(spinnerModel3);
		spinner_vscale.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				vscale = (Integer) ((JSpinner) e.getSource()).getValue();
				vscale = 1; // changed for tornado
			}
		});
		panel2.add(spinner_vscale);

		// Cylinder params:

		panel2.add(new JLabel("Base Radius"));
		SpinnerModel spinnerModel4 = new SpinnerNumberModel(
				Float.valueOf(0.1f), Float.valueOf(0.0f), Float.valueOf(10.0f),
				Float.valueOf(0.1f));
		JSpinner cy_bRadius = new JSpinner(spinnerModel4);
		cy_bRadius.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				bRadius = (Float) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel2.add(cy_bRadius);

		panel2.add(new JLabel("Top Radius"));
		SpinnerModel spinnerModel5 = new SpinnerNumberModel(
				Float.valueOf(0.1f), Float.valueOf(0.0f), Float.valueOf(10.0f),
				Float.valueOf(0.1f));
		JSpinner cy_tRadius = new JSpinner(spinnerModel5);
		cy_tRadius.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				tRadius = (Float) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel2.add(cy_tRadius);

		panel2.add(new JLabel("Height"));
		SpinnerModel spinnerModel6 = new SpinnerNumberModel(
				Float.valueOf(4.4f), Float.valueOf(0.0f), Float.valueOf(10.0f),
				Float.valueOf(0.1f));
		JSpinner cy_height = new JSpinner(spinnerModel6);
		cy_height.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				height = (Float) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel2.add(cy_height);

		panel2.add(new JLabel("Slices"));
		SpinnerModel spinnerModel7 = new SpinnerNumberModel(50, 10, 100, 10);
		JSpinner cy_slices = new JSpinner(spinnerModel7);
		cy_slices.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				slices = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel2.add(cy_slices);

		panel2.add(new JLabel("Stacks"));
		SpinnerModel spinnerModel8 = new SpinnerNumberModel(50, 10, 100, 10);
		JSpinner cy_stacks = new JSpinner(spinnerModel8);
		cy_stacks.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				stacks = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel2.add(cy_stacks);

		return panel2;
	}

	private static JPanel getDataSourcePanel() {
		JPanel panel3 = new JPanel(new GridLayout(5, 3));
		panel3.add(new JLabel("lower X"));
		JSpinner lower_xaxis = new JSpinner(new SpinnerNumberModel(71, 1, 128,
				1));
		lower_xaxis.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				lowChunkX = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel3.add(lower_xaxis);

		panel3.add(new JLabel("lower Y"));
		JSpinner lower_yaxis = new JSpinner(new SpinnerNumberModel(16, 1, 128,
				1));
		lower_yaxis.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				lowChunkY = (Integer) ((JSpinner) e.getSource()).getValue();
				System.out.println("Show the val: " + lowChunkY);
			}
		});
		panel3.add(lower_yaxis);

		panel3.add(new JLabel("lower Z"));
		JSpinner lower_zaxis = new JSpinner(new SpinnerNumberModel(21, 1, 128,
				1));
		lower_zaxis.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				lowChunkZ = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel3.add(lower_zaxis);

		panel3.add(new JLabel("upper X"));
		JSpinner upper_xaxis = new JSpinner(new SpinnerNumberModel(110, 1, 128,
				1));
		upper_xaxis.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				upChunkX = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel3.add(upper_xaxis);

		panel3.add(new JLabel("upper Y"));
		JSpinner upper_yaxis = new JSpinner(new SpinnerNumberModel(55, 1, 128,
				1));
		upper_yaxis.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				upChunkY = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel3.add(upper_yaxis);

		panel3.add(new JLabel("upper Z"));
		JSpinner upper_zaxis = new JSpinner(new SpinnerNumberModel(30, 1, 128,
				1));
		upper_zaxis.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				upChunkZ = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel3.add(upper_zaxis);

		panel3.add(new JLabel("Chunk Slice"));

		JSpinner chunk_slice = new JSpinner(new SpinnerNumberModel(30, 1, 128,
				1));
		chunk_slice.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				slice = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel3.add(chunk_slice);

		panel3.add(new JLabel("Chunk Volume"));
		JSpinner chunk_init = new JSpinner(new SpinnerNumberModel(50, 2, 63, 1));

		chunk_init.setLocation(400, 400);
		chunk_init.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				chunkSizeOfX = (Integer) ((JSpinner) e.getSource()).getValue();
				chunkSizeOfY = chunkSizeOfZ = chunkSizeOfX;
			}
		});
		panel3.add(chunk_init);

		return panel3;

	}

	private static JPanel getMRSourcePanel() {
		JPanel panel4 = new JPanel(new FlowLayout());

		mrView = new JCheckBox("MR VIEW");
		mrView.setActionCommand("MR VIEW");
		mrView.setSelected(true);
		panel4.add(mrView);

		panel4.add(new JLabel("DATA RESOLUTION"));
		JSpinner dsResolution = new JSpinner(new SpinnerNumberModel(0, 0, 2, 1));
		dsResolution.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				preRes = dsRes;
				dsRes = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel4.add(dsResolution);

		changeRS = new JCheckBox("CHANGE RES");
		changeRS.setActionCommand("CHANGE RES");
		changeRS.setSelected(false);
		panel4.add(changeRS);

		showError = new JCheckBox("ERROR DISPLAY");
		showError.setActionCommand("ERROR DISPLAY");
		showError.setSelected(false);
		panel4.add(showError);

		panel4.add(new JLabel("ERROR RESOLUTION"));
		JSpinner errResolution = new JSpinner(
				new SpinnerNumberModel(1, 0, 2, 1));
		errResolution.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				errRes = (Integer) ((JSpinner) e.getSource()).getValue();
			}
		});
		panel4.add(errResolution);

		// mrShowFullBounds = new JCheckBox("FULL BOUNDS");
		// mrShowFullBounds.setActionCommand("FULL BOUNDS" );
		// mrShowFullBounds.setSelected(true) ;
		// panel3.add(mrShowFullBounds) ;

		arView = new JCheckBox("AR VIEW");
		arView.setActionCommand("AR VIEW");
		arView.setSelected(false);
		panel4.add(arView);

		return panel4;
	}

	private static void openAndActivateDatasources() {
		ds1 = openDataSource("MainDataSourceFileX", mainFile1);
		ds1.activate();
		ds2 = openDataSource("MainDataSourceFileY", mainFile2);
		ds2.activate();
		ds3 = openDataSource("MainDataSourceFileZ", mainFile3);
		ds3.activate();

		// //dsHelix = openDataSource("Helix Flow",
		// "HelixFlow/helix_float.xfdl");
		// dsHelix = openDataSource("Tornado Flow",
		// "TornadoData/tornadoTime-0.xfdl");
		// dsHelix.activate();
	}

	private static void setParticlesInitialData() {

		int limit = 0;
		int initChunk = 50;
		if (arView.isSelected()) {
			limit = initChunk;
		} else if (dsRes == 0) {
			limit = chunkSizeOfX;
		} else if (dsRes > 0) {
			limit = arStorage[0].getDsArr(dsRes).getBounds().getUpper(1);
		}

		limit = 127;
		for (int y = 0; y < parCt; y++) {

			float xS, yS, zS;
			while (true) {
				xS = (float) rand.nextInt(limit);
				xS = xS + (xS % 5);
				yS = (float) rand.nextInt(limit);
				yS = yS + (yS % 5);
				zS = (float) rand.nextInt(limit);
				zS = zS + (zS % 5);
				if ((xS > 0 && xS < limit) && (yS > 0 && yS < limit)
						&& (zS > 0 && zS < limit)) {
					break;
				}
			}

			if (streamlets[y] == null) {
				streamlets[y] = new Streamlet();
			} else {
				streamlets[y].cleanUp();
			}
			streamlets[y].xval = xS;
			streamlets[y].yval = yS;
			streamlets[y].zval = zS;
			streamlets[y].initx = xS;
			streamlets[y].inity = yS;
			streamlets[y].color1[0] = red;
			streamlets[y].color1[1] = blue;
			streamlets[y].color1[2] = green;

			red = red - 0.6f;
			green = green - 0.2f;
			blue = blue - 0.4f;
			if (red <= 0.2f) {
				red = 1.0f;
			}
			if (green <= 0.2f) {
				green = 1.0f;
			}
			if (blue <= 0.2f) {
				blue = 1.0f;
			}
		}

	}

	/**
	 * Creates Datablock for each dimension DataSource.
	 * 
	 * @param res
	 *            Resolution value for getting the specific res data source.
	 * 
	 *            Note : If the resolution is 0, then its the original data, so
	 *            chunk user interaction is only for res 0 Can be changed later
	 *            for any resolution.
	 */
	public static void createDataBlock(int res) {

		int[] lower = new int[3];
		int[] upper = new int[3];

		ds1 = arStorage[0].getDsArr(res);
		ds2 = arStorage[1].getDsArr(res);
		ds3 = arStorage[2].getDsArr(res);

		if (dsRes == 0) {
			lower[0] = lowChunkX;
			lower[1] = lowChunkY;
			lower[2] = lowChunkZ;
			upper[0] = upChunkX;
			upper[1] = upChunkY;
			upper[2] = upChunkZ;
			ISBounds chunkDimension = new ISBounds(new IntegerIndexSpaceID(
					chunkSizeOfX, chunkSizeOfY, chunkSizeOfZ));

			block_DS1 = ds1.subblock(chunkDimension);
			ds1.subblock(block_DS1, new ISBounds(lower, upper));

			block_DS2 = ds2.subblock(chunkDimension);
			ds2.subblock(block_DS2, new ISBounds(lower, upper));

			block_DS3 = ds3.subblock(chunkDimension);
			ds3.subblock(block_DS3, new ISBounds(lower, upper));

		} else {
			block_DS1 = block_DS2 = block_DS3 = null;

			block_DS1 = ds1.subblock(ds1.getBounds());
			ds1.subblock(block_DS1, ds1.getBounds());

			block_DS2 = ds2.subblock(ds2.getBounds());
			ds2.subblock(block_DS2, ds2.getBounds());

			block_DS3 = ds3.subblock(ds3.getBounds());
			ds3.subblock(block_DS3, ds3.getBounds());
		}

		// int low[] = { 0, 0, 0 } ; int[] up = { 9, 9, 9 } ;
		// dbHelix = dsHelix.subblock(chunkDimension);
		// dsHelix.subblock(dbHelix, new ISBounds(low, up)) ;

	}

	public static float getPosValueInDataSource(DataBlock block, int x, int y,
			int z) {
		IndexSpaceID pos = new IntegerIndexSpaceID(z, y, x);

		Datum dat = block.createDatum();
		block.datum(dat, pos);
		return dat.getFloat(0);

	}

	public static Datum getDatumByPosition(DataBlock block, int x, int y, int z) {
		IndexSpaceID pos = new IntegerIndexSpaceID(z, y, x);
		Datum dat = block.createDatum();
		block.datum(dat, pos);
		return dat;

	}

	private void generateARStorageData() {
		String[] file_x = new String[2];
		file_x[0] = "TornadoData/Tornado-vx/tornado-vx.";
		file_x[1] = "xfdl";
		arSparseDS[0] = new ARSparseDataSource(file_x, "");
		arStorage[0] = arSparseDS[0].getArSparseStorage();

		String[] file_y = new String[2];
		file_y[0] = "TornadoData/Tornado-vy/tornado-vy.";
		file_y[1] = "xfdl";
		arSparseDS[1] = new ARSparseDataSource(file_y, "") ;
		arStorage[1] = arSparseDS[1].getArSparseStorage() ; 

		String[] file_z = new String[2];
		file_z[0] = "TornadoData/Tornado-vz/tornado-vz.";
		file_z[1] = "xfdl";
		arSparseDS[2] = new ARSparseDataSource(file_z, "");
		arStorage[2] = arSparseDS[2].getArSparseStorage() ; 

	}

	public static Point3D getPosValueInARDatasource(IntegerIndexSpaceID id,
			int index) {

	 System.out.println("Traversing  in the loop and found the AR Block index....");
		// ;
		ArrayList<ARNode> list = arStorage[index].getBlockList();
		int h = 0;
		for (h = 0; h < list.size(); h++) {
			boolean withinBlock = false;
			ISBounds blkbounds = list.get(h).getBlock().getBounds();
			// index space dimensions for loop
			for (int d = 0; d < id.dim(); d++) {
				if (id.getCoord(d) >= blkbounds.getLower(d)
						&& id.getCoord(d) <= blkbounds.getUpper(d)) {
					withinBlock = true;
				} else {
					withinBlock = false;
					break;
				}
			}
			if (withinBlock == true) {
				break;
			}
		}

		// System.out.println("Found the AR Index... " ) ;

		ARStorageBlock arBlock_x = arStorage[0].getArStorageBlockTable().get(h);
		ARStorageBlock arBlock_y = arStorage[1].getArStorageBlockTable().get(h);
		ARStorageBlock arBlock_z = arStorage[2].getArStorageBlockTable().get(h);

		// System.out.println("Index : " + h + "id " + id);
		if (arBlock_x != null && arBlock_y != null && arBlock_z != null) {
			ISBounds arBounds = arBlock_x.getArBlockBounds();
			int[] exacLoc = new int[3];
			exacLoc[0] = id.getCoord(0) - arBounds.getLower(0);
			exacLoc[1] = id.getCoord(1) - arBounds.getLower(1);
			exacLoc[2] = id.getCoord(2) - arBounds.getLower(2);

			// System.out.println("Getting the delta from the dagta block.... "
			// ) ;
			IntegerIndexSpaceID offsetCalcuID = new IntegerIndexSpaceID(
					exacLoc[0], exacLoc[1], exacLoc[2]); // slice(z), column
															// (y), row (x)

			Point3D point = new Point3D(arBlock_x.getArDataBlock().getFloat(
					offsetCalcuID, 0), arBlock_y.getArDataBlock().getFloat(
					offsetCalcuID, 0), arBlock_z.getArDataBlock().getFloat(
					offsetCalcuID, 0));
			// delta.sx = arBlock_x.getArDataBlock().getFloat(offsetCalcuID, 0)
			// ;
			// delta.sy = arBlock_y.getArDataBlock().getFloat(offsetCalcuID, 0)
			// ;
			// delta.sz = arBlock_z.getArDataBlock().getFloat(offsetCalcuID, 0);
			return point;

		}

		return new Point3D(0.0f, 0.0f, 0.0f);
	}

	public static int getPosARBlockIndex(IntegerIndexSpaceID id, int index) {

		ArrayList<ARNode> list = arStorage[index].getBlockList();
		int h = 0;
		for (h = 0; h < list.size(); h++) {
			boolean withinBlock = false;
			ISBounds blkbounds = list.get(h).getBlock().getBounds();
			// index space dimensions for loop
			for (int d = 0; d < id.dim(); d++) {
				if (id.getCoord(d) >= blkbounds.getLower(d)
						&& id.getCoord(d) <= blkbounds.getUpper(d)) {
					withinBlock = true;
				} else {
					withinBlock = false;
					break;
				}
			}
			if (withinBlock == true) {
				break;
			}
		}

		return h;

	}

	private void generateErrorData() {

		String[] errorXNames = arStorage[0].getArDataSource()
				.getErrorFDLNames();
		errDSx = new DataSource[errorXNames.length];

		errDSx[0] = null;
		for (int i = 1; i < errorXNames.length; i++) {

			errDSx[i] = DataSource.create("errDS", errorXNames[i]);
			errDSx[i].activate();
		}

		String[] errorYNames = arStorage[1].getArDataSource()
				.getErrorFDLNames();
		errDSy = new DataSource[errorYNames.length];

		errDSy[0] = null;
		for (int i = 1; i < errorYNames.length; i++) {

			errDSy[i] = DataSource.create("errDS", errorYNames[i]);
			errDSy[i].activate();
		}

		String[] errorZNames = arStorage[2].getArDataSource()
				.getErrorFDLNames();
		errDSz = new DataSource[errorZNames.length];

		errDSz[0] = null;
		for (int i = 1; i < errorZNames.length; i++) {
			errDSz[i] = DataSource.create("errDS", errorZNames[i]);
			errDSz[i].activate();
		}

	}

	private void creatErrorBlocks() {

		errBlock_x = null;
		errBlock_y = null;
		errBlock_z = null;

		errBlock_x = errDSx[errRes].subblock(errDSx[errRes].getBounds());
		errDSx[errRes].subblock(errBlock_x, errDSx[errRes].getBounds());

		errBlock_y = errDSy[errRes].subblock(errDSy[errRes].getBounds());
		errDSy[errRes].subblock(errBlock_y, errDSy[errRes].getBounds());

		errBlock_z = errDSz[errRes].subblock(errDSz[errRes].getBounds());
		errDSz[errRes].subblock(errBlock_z, errDSz[errRes].getBounds());

	}

	/**
	 * Method for creating error values display.
	 */
	private void showErrorDisplay(GL gl) {
		// TO-DO : need to change the data accessing position as slice, column,
		// row

		// always assuming that y and x axis have same bounds in the data sets.
		int errYlimit = errBlock_x.getBounds().getUpper(1);
		int errXlimit = errYlimit;

		int mul = 1;
		if (errRes == 1) {
			mul = (1200 / 64);
		} else if (errRes == 2) {
			mul = (1200 / 32);
		}

		// 2D error display
		for (int y = 0; y < errYlimit; y++) {
			for (int x = 0; x < errXlimit; x++) {

				float ex = (getPosValueInDataSource(errBlock_x, x, y, slice) * -10);
				float ey = (getPosValueInDataSource(errBlock_y, x, y, slice) * -10);

				((GL2) gl).glColor3f(1.0f, 0.5f, 0.3f);

				((GL2) gl).glBegin(GL.GL_POINTS);
				((GL2) gl).glVertex2f((float) (x + ex) * mul, (float) (y + ey)
						* mul);
				((GL2) gl).glEnd();

			}
		}
	}

	/**
	 * Method that traverses to each AR node each time to access the data. -
	 * gives very slow performance, so not used any where.
	 * 
	 */
	public static Point3D get3DPointsARNodeTraversal(IntegerIndexSpaceID id) {

		ISBounds nodeBounds = arStorage[0].traverseAndGetBlockBounds(
				arStorage[0].getArDataSource().getRoot(), id);

		DataSource ards_x = arStorage[0].getDsArr(0);
		DataBlock arBlock_x = ards_x.subblock(nodeBounds);
		ards_x.subblock(arBlock_x, nodeBounds);

		DataSource ards_y = arStorage[1].getDsArr(0);
		DataBlock arBlock_y = ards_y.subblock(nodeBounds);
		ards_y.subblock(arBlock_y, nodeBounds);

		DataSource ards_z = arStorage[2].getDsArr(0);
		DataBlock arBlock_z = ards_z.subblock(nodeBounds);
		ards_z.subblock(arBlock_z, nodeBounds);

		if (arBlock_x != null && arBlock_y != null && arBlock_z != null) {

			Point3D point3D = new Point3D(arBlock_x.getFloat(id, 0),
					arBlock_y.getFloat(id, 0), arBlock_z.getFloat(id, 0));
			return point3D;
		}

		return new Point3D(0.0f, 0.0f, 0.0f);

	}

	public static int getScalingValue() {
		int mul = (1200 / 128);
		if (mrView.isSelected()) {
			if (dsRes == 1) {
				mul = (1200 / 64);
			} else if (dsRes == 2) {
				mul = (1200 / 32);
			}
		}
		return mul;
	}

	/**
	 * PERFORMANCE TEST: Add Particles in the ARNode level 1
	 */
	public void addParticlesInFirstLevelOfARTree(ARNode root) {
		
		

		int[][] lower = { { 0, 0, 0 }, { 63, 0, 0 }, { 0, 63, 0 },
				{ 63, 63, 0 }, { 0, 0, 63 }, { 63, 0, 63 }, { 0, 63, 63 },
				{ 63, 63, 63 } };
		int[][] upper = { { 63, 63, 63 }, { 127, 63, 63 }, { 63, 127, 63 },
				{ 127, 127, 63 }, { 63, 63, 127 }, { 127, 63, 127 },
				{ 63, 127, 127 }, { 127, 127, 127 } };

		for (int i = 0; i <= 7; i++) {
			ParticleARNode child = new ParticleARNode();
			child.setId("child" + i);
			child.setNodeBounds(new ISBounds(lower[i], upper[i]));

			for (Streamlet part : visibleList) {
				Point3f point3f = new Point3f() ; 
				point3f.set(part.xval, part.yval , part.zval) ; 
				
				if (withinBlock(child.getNodeBounds(), part) == true) {
					part.setMyBlock(i); 
					ARNode currTreeNode = (ARNode) arStorage[0].getTreeRoot().getChild(i) ; 
					part.setLeafNode(arStorage[0].traverseAndFindLeaf(currTreeNode, point3f )) ;
					child.addVisibleParticle(part);

				}
			}

			// adding leaves list to the regions.
			//child.setArLeaves(new ArrayList<ARNode>()) ;  
			//arSparseDS[0].getLeaves(i, arSparseDS[0].getTreeRoot(), child.getArLeaves());
			//System.out.println("added the ARNode list in the particle ARNode size : " + child.getArLeaves().size() ); 
		
			particleARRoot_x.children[i] = child;
			
			
		}
	}

	/*
	 * TEst
	 */

	/*
	 * Comparison of particle new position with the currently residing region
	 * bounds and then we inside we will
	 */
	public void updateParticlesInFirstLevelOfARTree() {

		for (int i = 0; i <= 7; i++) {
			ParticleARNode child = particleARRoot_x.children[i];
			// ARNode childRegion = child.getRegionNode() ;
			// ARNode newRegoin = null ;
			
			
			for (Streamlet part :child.getVisibleParticles() ) {
				// newREgion = childRegion.updateSibling(part.position
				// (IndexSpaceID))
				// if(newRegion != childRegion){ part.setRegionNode(..)
				Point3f point3f = new Point3f() ; 
				point3f.set(part.xval, part.yval , part.zval) ; 
				Integer outRegion = arStorage[0].updateSibling(child.getNodeBounds(), part.getMyBlock(), point3f);
			
				if (outRegion != part.getMyBlock()) {// part moved to another region
						 part.setMyBlock(outRegion) ;
						 ParticleARNode child2 = particleARRoot_x.children[outRegion] ;
						 child2.getVisibleParticles().add(part) ; 
						 child.getVisibleParticles().remove(part); 
				} 

				
				ARNode currentLeafNode = arStorage[0].updateLeaf(part.getLeafNode(), point3f) ; 
				part.setLeafNode(currentLeafNode); 
				
			}

		}
	}
	
	private boolean withinBlock(ISBounds nbnds, Streamlet part) {
		boolean withinBlock_x = false;
		boolean withinBlock_y = false;
		boolean withinBlock_z = false;

		if (part.xval >= nbnds.getLower(0) && part.xval < nbnds.getUpper(0)) {
			withinBlock_x = true;
		}
		if (part.yval >= nbnds.getLower(1) && part.yval < nbnds.getUpper(1)) {
			withinBlock_y = true;
		}
		if (part.zval > nbnds.getLower(2) && part.zval >= nbnds.getUpper(2)) {
			withinBlock_z = true;
		}

		return (withinBlock_x && withinBlock_y && withinBlock_z);
	}
	
	private void addRegionNodes(){
		
		
		for(int i = 0 ; i <= 7 ; i++){
			ARNode child = (ARNode) arSparseDS[0].getTreeRoot().getChild(i) ; 
			particleARRoot_x.children[i].setRegionNode(child) ; 
		}
		
		
	}
	
}
