package ar;

import java.util.List;

import org.testng.Assert;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import edu.unh.sdb.datasource.ARSparseDataSource;

public class ARSparseDataGenerationTest {

	private ARNode tree ; 
	
	private ARSparseDataGeneration arSparseDataGeneration ; 
	
	@BeforeMethod
	public void createTree(){
		String[] file_x = new String[2];
		file_x[0] = "Tornado_vx_Wavelet/tornado-vx.";
		file_x[1] = "xfdl";
		ARSparseDataSource arSparseDS = new ARSparseDataSource(file_x, "");
		ARSparseStorage arSparseStorage = arSparseDS.getArSparseStorage();
		tree = arSparseStorage.getTreeRoot();
		
		arSparseDataGeneration = new ARSparseDataGeneration(tree.getBlock().getResolution() + 1 , arSparseDS) ; 
		
	}
	
	
	
  @Test
  public void updateListTest() {
  
	   arSparseDataGeneration.updateList(tree) ; 
	   
	   List<List<ARNodeBlock>> list = arSparseDataGeneration.getArInfoList() ; 
	   
	   for(int i = 0 ; i < arSparseDataGeneration.getNoOfResolutions() ; i ++){
		   Assert.assertTrue(!(arSparseDataGeneration.getArInfoList().get(i).isEmpty()) , "List should not be empty for res " + i ) ; 
	   }
	   
	   arSparseDataGeneration.paddingARSparseDataBlocks() ; 

  
  }

  
  @Test
  public void printingARSparseDataBlocksCountsTest(){
	  // create a Data Block list for each resolution. 
	  // pad them with zeros.
	  
	  arSparseDataGeneration.updateList(tree) ; 
	  arSparseDataGeneration.printingARSparseDataBlocksCounts() ;
	  
  }

  @Test
  public void paddingARDataBlocksTest(){
	  arSparseDataGeneration.updateList(tree) ; 
	  arSparseDataGeneration.paddingARSparseDataBlocks() ; 
	  
	  for(int i = 0 ; i < arSparseDataGeneration.getNoOfResolutions() ; i++){
		  Assert.assertTrue(!arSparseDataGeneration.getArDataBlocksList().get(i).isEmpty(), "DataBlock list is Empty for res " + i) ; 
		  System.out.println("Size of dataBlocks at res " + i + " : " + arSparseDataGeneration.getArDataBlocksList().get(i).size()) ; 
	  }
	  
  }


}
