#include "SimCodeGlobals.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


extern void setCurrentDSID(int id);

static struct function_ptrs2 fptrs2;

static char DSName[128]="test";
static char DSPath[1024]="/local/data/jpo39/jcd0004.392x112x112.rr.xfdl";
static int  DSid=-99;

/*****************************************************************************
 * void registerGUICommandCallbacks
 *
 * args: struct function_ptrs fun_ptrs2
 *
 * purpose: Defines callbacks for the gui commands
 *
 * Author: Jon Frain (7/27/09)
 *
 *****************************************************************************/
void registerGUICommandCallbacks( struct function_ptrs2 fun_ptrs){
   fptrs2.createDataSource = fun_ptrs.createDataSource;
}


/*****************************************************************************
 * void processCustomGUICommand
 *
 * args: char* cmd
 *
 * purpose:
 *
 * Author: Jon Frain (7/27/09)
 *
 *****************************************************************************/
void processCustomGUICommand(const char* cmd)
{
   char* message = (char*)malloc(( strlen(cmd)+1) * sizeof(char));
   strcpy(message,cmd);
   char* tokens[6];

   int i=0;

   for (i=0;i<6;i++)
     tokens[i]=NULL;

   char* token;
   i=0;     

   token = strtok(message,";");
   while (token != NULL)
   {
      tokens[i] = token;
      i++;

      token = strtok (NULL, ";");      
   }


   if (strcmp(tokens[1],"LineEditDSName") == 0) {
     if (tokens[4] != NULL) {
        if (strlen(tokens[4]) > 0)
           strcpy(DSName,tokens[4]);
     }
     else
        strcpy(DSName,"NULL");
   
   }
   else if (strcmp(tokens[1],"LineEditDSPath") == 0) {
     if (tokens[4] != NULL) {
         if (strlen(tokens[4]) > 0)
           strcpy(DSPath,tokens[4]);
     }
     else
        strcpy(DSPath,"NULL");
      
   }
   else if (strcmp(tokens[1],"pushButtonCreateDS") == 0) {
     if ( (strlen(DSName)>0 && strcmp(DSName,"NULL") != 0 ) && 
          (strlen(DSPath)>0 && strcmp(DSPath,"NULL") != 0 ) )
     {
         fprintf(stderr, " Creating data source:  Name = %s     Path = %s \n",
                 DSName, DSPath);
         int id = fptrs2.createDataSource(DSName, DSPath);
         if (id != -99) {
            setCurrentDSID(id);
         }
     }
     else {
        fprintf(stderr, " Unable to Create data source!  Make sure you've" 
                       " entered a Name and Path!\n");   
     }
   
   }

   //if(strstr(cmd, "pushButtonCreateDS") == 0) {
   //  fprintf(stderr, "    Need to fetch DS name and path!!!\n");
   // }
}
