package ar;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.nio.ByteBuffer;
import java.nio.DoubleBuffer;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.nio.ShortBuffer;

import edu.unh.sdb.common.ByteValues;
import edu.unh.sdb.common.DoubleValues;
import edu.unh.sdb.common.FloatValues;
import edu.unh.sdb.common.IntValues;
import edu.unh.sdb.common.MixedValues;
import edu.unh.sdb.common.SDBError;
import edu.unh.sdb.common.ShortValues;
import edu.unh.sdb.common.Values;
import edu.unh.sdb.datasource.DataBlock;
import edu.unh.sdb.datasource.DataSource;
import edu.unh.sdb.datasource.FDLDescriptor;
import edu.unh.sdb.datasource.FileError;
import edu.unh.sdb.datasource.ISBounds;
import edu.unh.sdb.datasource.IntegerIndexSpaceID;

public class AbiSampleFileCreation {

	 static RandomAccessFile outData;
	 static String outPrefix = "tornado-vx";
	
	public static void main(String args[]){
		
		// create and activate the DS
		DataSource ds1 = DataSource.create("ds1", "TornadoData/tornadoTime-0.xfdl");
		ds1.activate();
		
		IntegerIndexSpaceID id = new IntegerIndexSpaceID(0, 0, 0) ; 
		float[] flo = ds1.getFloats(id) ; 
		System.out.println(" From all 3 attr " + flo[0] + ", " + flo[1] + ", " + flo[2]) ;  
		
		FloatValues vals = (FloatValues) ds1.getValues(0) ; 
		float[] dsfloatX = vals.floatValues();
		
		System.out.println(" From float vals " + dsfloatX[0]);
		
		
		
		//DataSource d1 = DataSource.create("d1", "/Users/AbinayaPitchai/Documents/IndependentStudy/granite/TornadoData/tornado-vx/tornado-vx.xfdl");
		DataSource d1 = DataSource.create("d1", "Data/tornado-vx/tornado-vx.xfdl");

		d1.activate();
		
		float[] flo2 = d1.getFloats(id)  ; 
		System.out.println(" From vx : " + flo2[0]) ;
		
	//	System.out.println(" From float vals  sss " + dsfloatX1[0]);
//		
//		DataSource d2 = DataSource.create("d2", "TornadoData/tornado-vy/tornado-vy.xfdl");
//		d2.activate();
//		
//		DataSource d3 = DataSource.create("d3", "TornadoData/tornado-vz/tornado-vz.xfdl");
//		d3.activate();
//		
	    
//		float[] flo2y =  d2.getFloats(id) ; 
//		float[] flo2z =  d3.getFloats(id) ; 
//		
		//System.out.println(" From all x file " + val.getBytes() ) ;
//		
		
//		byte[] bytevals =  ds1.getBytes() ; 
//		byte[] buffer = new byte[4] ; 
//		buffer[0] = bytevals[0] ; 
//		buffer[1] = bytevals[1] ; 
//		buffer[2] = bytevals[2] ; 
//		buffer[3] = bytevals[3] ; 
//		
//		ByteBuffer byteBuffer = ByteBuffer.wrap(buffer);
//		Float fl = byteBuffer.getFloat() ; 
//		
//		System.out.println(" ebrebre " + fl) ; 
// 		
		
		
		// create db
	//	DataBlock db1 = ds1.subblock(new ISBounds(new IntegerIndexSpaceID(128, 128, 128)));
		
		// extract the subblock for given bounds
//		int[] lower = { 0, 0, 0 } ;
//		int[] upper = { 2, 2, 2 } ;
//        ds1.subblock(db1, new ISBounds(lower, upper));
        
       
     
//       openOut();
//       
//      
//        try {
//        	byte[] bytevals2 = bytesFromValues((FloatValues) ds1.getValues(0)) ; 
//			outData.write(bytevals2);
//			
//			RandomAccessFile test = new RandomAccessFile("/Users/AbinayaPitchai/Documents/IndependentStudy/granite/TornadoData/tornado-vx/tornado-vx.bin", "rw");
//			
//			byte[] buffer2 = new byte[4];
//			long pos = 0 ; 
//			test.seek(pos) ; 
//			int x = test.read(buffer2) ;
//			ByteBuffer byteBuffer2 = ByteBuffer.wrap(buffer2);
//		    System.out.println("byteBuffer2.getFloat() " + byteBuffer2.getFloat() ) ; 
//			
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
        
  //   closeOut();
		
		System.out.println("Done");
	}
	
	 //------------------- openOut() -------------------------------
		protected static void openOut()
	   {
			try 
	      {        
	         outData = new RandomAccessFile( outPrefix + ".bin", "rw" );
	      } 
	      catch ( IOException e )
	      {
	         new FileError( SDBError.Recoverable, "Couldn't Open File:" + e);
	      }	
		}
		
		//------------------ closeOut() ----------------------------------
		protected static void closeOut()
	   {	
			try 
	      {
	         outData.close();            
			} 
	      catch (IOException e)
	      {
				new FileError( SDBError.Recoverable, "IO Error in close()." );
			}
		}	
	
		 static byte[] bytesFromValues( Values vals )
		   {
		      ByteBuffer bbuf = null;
		      if ( vals instanceof FloatValues )
		      {
		         float[] fvals = ((FloatValues)vals ).getFloats();
		         bbuf = ByteBuffer.allocate( fvals.length * 4 );
		         FloatBuffer fbuf = bbuf.asFloatBuffer();
		         fbuf.put(  fvals );        
		      }
		      else if ( vals instanceof DoubleValues )
		      {
		         double[] dvals = ((DoubleValues)vals ).getDataReference();
		         bbuf = ByteBuffer.allocate( dvals.length * 8 );
		         DoubleBuffer dbuf = bbuf.asDoubleBuffer();
		         dbuf.put(  dvals );                 
		      }
		      else if ( vals instanceof IntValues )
		      {
		         int[] ivals = ((IntValues)vals ).getDataReference();
		         bbuf = ByteBuffer.allocate( ivals.length * 4 );
		         IntBuffer ibuf = bbuf.asIntBuffer();
		         ibuf.put(  ivals );                 
		      }
		      else if ( vals instanceof ShortValues )
		      {
		         short[] svals = ((ShortValues)vals ).getDataReference();
		         bbuf = ByteBuffer.allocate( svals.length * 4 );
		         ShortBuffer sbuf = bbuf.asShortBuffer();
		         sbuf.put(  svals );                 
		      }
		      else if ( vals instanceof ByteValues )
		      {
		         byte[] bvals = ((ByteValues)vals ).getDataReference();
		         bbuf = ByteBuffer.wrap( bvals );
		      }
		      else if ( vals instanceof MixedValues )
		      {
		         byte[] bvals = ((MixedValues)vals ).getDataReference();
		         bbuf = ByteBuffer.wrap( bvals );
		      }
		      return bbuf.array();
		   }
	
}
