package com.application.objects.threeD;

/**
 * Cylinder.java -  class to create 3D cylinder
 *  			 -	 child class of Object3D 
 *  
 *  @author  Dupuis 
 *  edited by  Abinaya Pitchai 
 */

import javax.media.opengl.GL2;

import com.jogamp.opengl.util.gl2.GLUT;
import javax.media.opengl.glu.GLU;
import javax.media.opengl.glu.GLUquadric;

public class Cylinder extends Object3D {
	private GL2 gl;

	public Cylinder(GL2 g1, GLUT g2) {
		// default values
		xScale = yScale = zScale = 1.0f;
		xRot = yRot = zRot = 0.0f;
		xLoc = yLoc = 1.0f;
		zLoc = -100.0f;
		red = blue = 1.0f;
		green = 0.2f;
		gl = g1;
		radians = 180.0f;
	}

	@Override
	public void redraw() {
		gl.glPushMatrix();
		gl.glColor3f(red, green, blue);
		gl.glTranslatef(xLoc, yLoc, -1.0f);
		gl.glRotatef(90.0f, 0.0f, 1.0f, 0.0f);
		gl.glRotatef(radians, dr.xval, dr.yval, dr.zval);
		gl.glScalef(xScale + 4.0f, yScale + 4.0f, 0.25f);

		GLU glu = new GLU();
		GLUquadric qObj = glu.gluNewQuadric();
		glu.gluQuadricNormals(qObj, GLU.GLU_SMOOTH);
		glu.gluCylinder(qObj, baseRadius, topRadius, height, slices, stacks);

		gl.glPopMatrix();

	}

}
