//----------------------- AddLeafAction class ----------------------------
//
// AddLeafAction class -- generated from a template MakeParser.
//
//------------------------- Edit history (since 10/21/05) -----------------------
// 10/21/05 rdb: Cleaned up unused variables and some reformatting.
//-------------------------------------------------------------------------------

package edu.unh.sdb.ARRSTreeBuilder;
import java.io.*;
import java.util.Vector;
import edu.unh.sdb.util.CommandProcessor.CommandAction;

class AddLeafAction extends CommandAction
{
  private ARRSBuilder  builder = null;
  //--------------------------------------------------------------
  // Inherits following from CommandAction:
  //
  //    protected PrintWriter writer = null;
  //
  //    public AddLeafAction();              // writer = System.err
  //    public AddLeafAction( PrintWriter ); // writer = argument
  //    public AddLeafAction( PrintStream ); // writer = argument
  //       
  //--------------------------------------------------------------
  //
  public AddLeafAction( ARRSBuilder b )
  {
     super();
     this.builder = b;
  }
  public AddLeafAction( ARRSBuilder b, PrintWriter pw )
  {
     super( pw );
     this.builder = b;
  }
  public AddLeafAction( ARRSBuilder b, PrintStream ps )
  {
     super( ps );
     this.builder = b;
  }
  //
  //------------------ execute( Vector ) -------------------------
  // Default execute calls CommandAction.execute which prints out arguments.
  //
  public boolean execute( Vector args )
  {
     //super.execute( args );
     /*if ( this.builder == null )
        this.builder = ARRSCopyModelBuilder.get();
     */
     // make sure we have a reasonable # args
     //     should be 3*dim + 2: command
     //                          parent
     //                          2*dim for bounds
     //                          dim for size
     if (( args.size() - 2 ) % 3 != 0 )
        writer.println( "*** AddLeafAction ***: bad arg count: " + args.size() );
     int dim = ( args.size() - 2 ) / 3;   // infer dimensionality

     // check dimensionality
     if ( !this.builder.isDim( dim ))
        writer.println( "*** AddLeafAction ***: inferred dim error: " + dim );
     else
     {
        //rdb String command = (String) args.get( 0 );
        int parentid = ((Integer)args.get( 1 )).intValue();
        int boundsIndexes[] = new int[ 2 * dim ];
        int sizes[]         = new int[ dim ];
        int arg = 2;
        for ( int i = 0; i < dim*2; )
        {
           boundsIndexes[ i++ ] = ((Integer)args.get( arg++ )).intValue();
           boundsIndexes[ i++ ] = ((Integer)args.get( arg++ )).intValue();
        }
        for ( int i = 0; i < dim; i++ ) 
           sizes[ i ] = ((Integer)args.get( arg++ )).intValue();
        this.builder.addLeaf( parentid, boundsIndexes, sizes );
     }
     return true;
  }
}
