//----------------------- AddNodeAction class ----------------------------
//
// AddNodeAction class -- generated from a template MakeParser.
//
// input:  cmd parent nDBounds   # where ndBound needs 2*dim integers 
//

package edu.unh.sdb.ARRSTreeBuilder;
import java.io.*;
import java.util.Vector;
import edu.unh.sdb.util.CommandProcessor.CommandAction;

class AddNodeAction extends CommandAction
{
  private ARRSBuilder  builder = null;
  //--------------------------------------------------------------
  // Inherits following from CommandAction:
  //
  //    protected PrintWriter writer = null;
  //
  //    public AddNodeAction();              // writer = System.err
  //    public AddNodeAction( PrintWriter ); // writer = argument
  //    public AddNodeAction( PrintStream ); // writer = argument
  //       
  //--------------------------------------------------------------
  //
  public AddNodeAction( ARRSBuilder b )
  {
     super();
     this.builder = b;
  }
  public AddNodeAction( ARRSBuilder b, PrintWriter pw )
  {
     super( pw );
     this.builder = b;
  }
  public AddNodeAction( ARRSBuilder b, PrintStream ps )
  {
     super( ps );
     this.builder = b;
  }
 
  //------------------ execute( Vector ) -------------------------
  // Default execute calls CommandAction.execute which prints out arguments.
  //
  public boolean execute( Vector args )
  {
     //super.execute( args );
     /*if ( this.builder == null )
        this.builder = ARRSCopyModelBuilder.get();
     */
     // make sure we have a reasonable # args
     //     should be 2*dim + 2
     if (( args.size() ) % 2 != 0 )
        writer.println( "*** AddNodeAction *** bad arg count: " + args.size() );
     int dim = ( args.size() - 2 ) / 2;   // infer dimensionality

     // check dimensionality
     if ( !this.builder.isDim( dim ))
        writer.println( "*** AddNodeAction ***: inferred dim error: " + dim );
     else
     {
        String command = (String) args.get( 0 );
        int parentid = ((Integer)args.get( 1 )).intValue();
        int boundsIndexes[] = new int[ 2 * dim ];
        int arg = 2;
        //System.out.println( command + ":"  + dim + " " + args.size());
        for ( int i = 0; i < dim*2; )
        {
           boundsIndexes[ i++ ] = ((Integer)args.get( arg++ )).intValue();
           boundsIndexes[ i++ ] = ((Integer)args.get( arg++ )).intValue();
        }
        if ( command.startsWith( "k" ))
           this.builder.addKdNode( parentid, boundsIndexes );
        else if ( command.startsWith( "n" ))
           this.builder.addNtreeNode( parentid, boundsIndexes );
     }
     return true;
  }
}
