//
//  FloatDataArray.java
//  Unstructured
//
//  Created by Philip Rhodes on Mon Oct 21 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//




package edu.unh.sdb.common;

import edu.unh.sdb.datasource.*;
//import java.io.*;


public class FloatDataArray extends DataArray {

    float [] data;

    public FloatDataArray(int [] dimensions){
    
        super(dimensions);
        
        int volume=1;
        
        for(int i=0;i<dimensions.length;i++){
            volume*=dimensions[i];
        }
        
        data=new float[ volume ];
    }
    
    public FloatDataArray(int [] dimensions, AxisOrdering ordering){
    
    	super(dimensions, ordering);
        
        int volume=1;
        
        for(int i=0;i<dimensions.length;i++){
            volume*=dimensions[i];
        }
        
        data=new float[ volume ];

    }

    public final void set(int [] coords, float value){
    
        data[(int)AxisOrdering.computeOffset(coords, this.axisWeights)]=value;
    }
    
    
    public final float get(int [] coords){
    
        return data[(int)AxisOrdering.computeOffset(coords, this.axisWeights)];
    }
    
    // For testing only.
    public static void main(String argv[]){
    
        FloatDataArray fda=new FloatDataArray(new int[]{10,10,10});
        
        fda.set(new int[] {5,4,3}, 2.45f);
        
        System.out.println("fda[5,4,3]="+fda.get(new int[]{5,4,3}));
    }
    
}
