//
//  UserType.java
//  DS2Test
//
//  Created by Philip Rhodes on Mon Jan 21 2002.
//  Copyright (c) 2001 University of New Hampshire. All rights reserved.
//

package edu.unh.sdb.common;


/** The UserType class represents user defined types in the SDB system. Simple user defined
 *  types may be defined in terms of a storage type and a name. */
public class UserType extends Type {

    protected int storageType;
    
    public UserType(String name, int storageType){
        
        super(name);
        
        this.storageType=storageType;

        if(!StorageType.isStorageType(storageType)){
            new IllegalArgumentError(SDBError.Fatal,"The type code given to the UserType constructor is not a storage type.");
        }
     }

    public int getStorageType(){

        return storageType;
    }


    public boolean equals(Object obj){
        UserType u=(UserType) obj;

        return (super.equals(obj)) && (this.storageType == u.storageType);
    }
    
    
    /** Return a representation of this object as a nicely formatted String. This method is meant to be called
        by the toString method of child classes only.*/
    public String toString(){

        StringBuffer result=new StringBuffer(super.toString());
        
        result.append(StorageType.intToTypeString(this.storageType));
        
        return new String(result);
    }

    
}
