/*
  ARRSCell.java
  Copyright 2004 University of New Hampshire
  Durham, NH 03824
  Programmer: LI YE
*/
                                                                                
/**
 * The ARRSCell class provides an interface to view the data of a cell in an
 * ARRS tree. It is extended from RectilinearCell class.
 */
                                                                                

package edu.unh.sdb.datasource;
                                                                                
//import java.io.*;
import edu.unh.sdb.common.*;
                                                                                
public class ARRSCell extends RectilinearCell {

   /** construction without arguments */ 
   public ARRSCell()
   {
      super();
   }
  
   /** Constructor with the specified cell id */
   public ARRSCell(CellID cellid) 
   { 
      super(cellid);
   }

   /** Constructor with the specified cell id and dimensionality */
   public ARRSCell(CellID cellid, int dim) 
   { 
      super(cellid, dim);
   }

   /** Constructor with the specified cell id and base bounds */
   public ARRSCell(CellID cellid, ISBounds bounds) 
   { 
      super(cellid, bounds);
   }

   /** Return a String representing the object indented by the argument string.
     */
   public String toString(String indent){
      int i;
      String indent2=indent+Globals.toStringIndent;
      StringBuffer result=new StringBuffer(indent+"{ ARRSCell:\n");
        
      result.append(((ARRSCellID)this.cellID).toString(indent2)+"\n");
      result.append(indent2+"Base bounds: ");
      result.append(this.baseBounds.toString()+"\n");
      if (this.vertices != null) {
         result.append(indent2+"Vertices: \n");
         for (i = 0; i < this.vertices.length-1; i++) {
            result.append(this.vertices[i].toString(indent2)+",");
         }
                                                                                
         result.append(this.vertices[this.vertices.length-1].toString(indent2)+"\n");
      }
      result.append(indent+"}");
      return new String(result);
   } 

}
