/*
    ARRSLeafNode.java
    Copyright 2005 University of New Hampshire
    Durham, NH 03824
    Programmer: rdb
*/
                                                                               
/**
 *  ARRSLeafNode is an abstract class to represent all leaf node.
 */

//--------------------- Edit history -------------------------------
// 12/26/05 rdb: getRegionData only calls setRegionData if the data is not there.
//                 (I hope ARCellBlocks are not reused ??)
// 11/01/05 rdb: Created in order to provide an abstraction of different kinds
//               of leaf nodes. The previous ARRSLeafNode class was renamed to
//               ARRSCopyLeafNode.
//-------------------------------------------------------------------

package edu.unh.sdb.datasource;

//import java.io.*;

abstract public class ARRSLeafNode extends ARRSNode 
{
   protected DataBlock theRegionData;
   //private RecordDescriptor recordDesc;   

   /** Constructor without argument */
   public ARRSLeafNode()
   {
      this( null );
   }
                                                                                
   /** Constructor takes a single ISbounds */
   public ARRSLeafNode( ISBounds bounds )
   {
      this( bounds, null );
   }
                                                                                
   /** Constructor takes a ISbounds and a cell block */
   public ARRSLeafNode( ISBounds bounds, CellIndexable cellSource )
   {
      super( bounds, cellSource );
      this.theRegionData = null;
   }

   /** Get the uniform region cell data */
   public DataBlock getRegionData()
   {
      if ( this.theRegionData == null )  //rdb 
         this.setRegionData();
      return this.theRegionData;
   }
 
   /** Set an uniform region cell data*/
   abstract protected void setRegionData();
}
