/* 
	CacheDataBlock.java
	Copyright 2000 University of New Hampshire
	Durham, NH 03824
*/

package edu.unh.sdb.datasource;

import edu.unh.sdb.common.*;
//import java.io.*;

/** A CacheDataBlock is a CompositeBlock that is used internally by the CacheDataSource. */
//FIXME: remove "public" after testing 

public class CacheDataBlock extends BasicBlock {

    protected long tag;
    boolean pending= false; // true if the data corresponding to the tag 
                     // has not yet been read into this block.
                     // Used by mbcds.addToStencil()


	/** Construct a datablock with the given ISBounds and RecordDescriptor. 
      * The default axis axisOrdering is used, and the bounds will be moved to the origin.
	  * The tag value is set to -999. */	
	CacheDataBlock(ISBounds isb,RecordDescriptor recordDesc){ 
		
      super(isb,recordDesc);
      this.tag=-999;
    }
    
   /** Construct a datablock with the given ISBounds, RecordDescriptor, and axisOrdering. 
   * The bounds will be moved to the origin.
   * The tag value is set to -999. */	
   CacheDataBlock(ISBounds isb,RecordDescriptor recordDesc, AxisOrdering cacheBlockOrdering)
   { 
      super( isb, recordDesc, cacheBlockOrdering );
      this.tag=-999;
   }

    
    /** Return the tag value for this block.*/
	final long getTag(){
        
        return this.tag;
	}

	/** Set the tag value for this block.*/
    final void setTag(long tag){
        
        this.tag=tag;
    }

    
}