
/* 
    CellDataSource.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    Programmer: LI YE
*/

//------------------- Edit history -----------------------------------------
// 11/01/05 rdb: Added implements CellIndexable
//--------------------------------------------------------------------------

/** 
 * CellDataSource is an abstract class meant to serve as a parent class 
 * for all kinds of cell data sources. It provide a view of the data in
 * an N-dimensional cell space.
 */

package edu.unh.sdb.datasource;

import edu.unh.sdb.common.*;
//import java.io.*;

abstract public class CellDataSource extends DataSource implements CellIndexable
{
    /** Constructor without arguments */
    protected CellDataSource()
    {
       super( "" );
    }

    /** Constructor with RecordDescriptor and ISBounds */
    protected CellDataSource(RecordDescriptor r, ISBounds db)
    {
       super("", r, db);
    }

    /** Constructor sets all data members to copies of the
     *  corresponding members from the argument DataSource.
     */
    protected CellDataSource (DataSource ds) 
    { 
      super(ds);
    }
}
