/*
  CellID.java
  Copyright 2004 University of New Hampshire
  Durham, NH 03824
  Programmer: LI YE
*/

/**
 * The CellID class indicates the identifier of a cell in a cell space
 */                                                                                  
package edu.unh.sdb.datasource;
                                                                                
//import java.io.*;
//import edu.unh.sdb.common.*;
                                                                               
public abstract class CellID {
   protected IndexSpaceID position;
       //store the position of a cell in a cell space

   /** Constructor without argument */
   public CellID()
   {
      this.position = null;
   }
 
   /** Constructor takes a single IndexSpaceID that represents the position
     * of a cell in a cell space.
     */
   public CellID(IndexSpaceID p)
   {
      this.position = p;
   }

   /** Get the position of a cell in a cell space */
   public IndexSpaceID getPosition()
   {
      return this.position;
   }

   /** Set the position of a cell in a cell space */
   public void getPosition(IndexSpaceID p)
   {
      this.position = p;
   }

   /** Return a String representing the object. */
   public String toString(){
        return this.toString("");
    }

   /** Return a String representing the object indented by the argument string.
     */
   public abstract String toString(String indent);
}
