/*
    CellIterator.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    Programmer: LI YE
*/
                                                                                
/**
 * The CellIterator class provides an interface to iterate through
 * a cell space.
 */

package edu.unh.sdb.datasource;
                                                                                
//import java.io.*;
                                                                                
//import edu.unh.sdb.common.*;
                                                                                
public abstract class CellIterator {
    protected ARRSCell cell;  //store an ARRS cell
    protected boolean valid = false;
    
    /** Constructor without argument */
    public CellIterator()
    {
       this. cell = null;
    }

    /** Return true if the current position is valid */
    public boolean valid()
    {
       return this.valid;
    }

    /** Initialize this CellIterator object */
    public abstract void init();

    /** Moving the CellIterator to the next position. */
    public abstract boolean next();

    /** Get a cell */
    public Cell getCell()
    {
       return this.cell;
    }

    /** Return a String representing the object. */
    public String toString(){
        return this.toString("");
    }
     
    /** Return description of this ARRSCell */
    public abstract String toString(String indent);
                                                                                
}

