package edu.unh.sdb.datasource;

/**************************************************************************** 
 * ChomboErrors:
 * 
 * This is a class containing constant integer values referencing the various
 * errors that may occur in the ChomboReader.
 * 
 * @author  Michael Hodges
 * @version 0.1b
 ****************************************************************************/

public class ChomboErrors
{
    // Error codes 101-199:  HDF5LibraryException errors (L)    
    public static final int L_BAD_FILE_FORMAT       = 102;
    public static final int L_INVALID_COMPONENTS    = 103;
    public static final int L_INVALID_DIMENSIONS    = 104;
    public static final int L_NUM_LEVELS_NOT_FOUND  = 105;
    public static final int L_REF_RATIO_NOT_FOUND   = 106;
    public static final int L_TIMESTEP_NOT_FOUND    = 107;
    public static final int L_LEVEL_NOT_FOUND       = 108;
    public static final int L_PROB_DOMAIN_NOT_FOUND = 109;
    public static final int L_BOX_NOT_FOUND         = 110;
    public static final int L_INVALID_DATA          = 111;
    public static final int L_FILE_CLOSE_ERROR      = 112;
    
    // Error codes 201-299:  General HDF5Exception errors (G)
    // Note:  There are usually just programming bugs, and should not generally
    //        be encountered by the application user.
    public static final int G_INCORRECT_ID_TYPE  = 201;
}