//
//  DSStencilIterator.java
//  StencilTest
//
//  Created by Philip Rhodes on 5/25/06.
//  Copyright 2006 Philip J Rhodes. All rights reserved.
//

package edu.unh.sdb.datasource;

import edu.unh.sdb.common.*;


//public class DSThreadedPartitionedStencilIterator extends DataBlock implements SDBIterator{
public class DSThreadedPartitionedStencilIterator extends DSPartitionedStencilIterator{
 //  DataSource source;
//   DSPartitionedStencil stencil;
//   
//   
//   
//   int numStencilPartitions = 0;
//   int currentPartition = 0;
//   ISBounds partitionBounds;
//   
//   boolean valid=false;

   BasicBlock [] theBlocks = new BasicBlock[2];

   
   private IOThread ioThread;

   public DSThreadedPartitionedStencilIterator(DSPartitionedStencil stencil, DataSource ds){

      super(stencil, ds);
      
//      super(new ISBounds(stencil.getPartitionDimensions()), ds.getRecordDescriptor());
//   
//      this.stencil = stencil;
//      
//      this.source = ds;
//      
//      partitionBounds = new ISBounds(stencil.dim());
      
      
      
      
      theBlocks[0] = new BasicBlock(this.bounds, this.recordDesc);
      theBlocks[1] = new BasicBlock(this.bounds, this.recordDesc);
      
      
   }
   

   /** Perform any necessary initialization, and set the iterator value
   *  to the first value in the iteration. If the stencil contains no
   *  elements, then the value of this iterator is undefined, but valid()
   *  will return false. However, activate() is still called on the 
   *  underlying datasource.
   */
   public void init(){
      
      super.init();
      
      if ( this.numStencilPartitions > 0){
      
         this.ioThread = new IOThread(this, 1);
         this.ioThread.start();
      }
   }

   /** Advance the iterator by one step. If the iterator cannot be advanced
   *  to produce a valid value, the value of the iterator is undefined, but
   *  the next() method will return false, as will a subsequent call to
   *  valid().
   */
   public boolean next(){
      
      if(this.currentPartition + 1 < this.numStencilPartitions){

         if( !this.ioThread.isDone ){
            
            //System.out.println("Waiting...");
            
            try{
               this.ioThread.join();
            } catch(InterruptedException e) {
               
               new SDBError(SDBError.Recoverable, "**** Main thread was interrupted");
               this.load(this.currentPartition++);
               return true;
            }
         }
      
         this.currentPartition++;
         
         this.ioThread = new IOThread(this, this.currentPartition + 1);
			this.ioThread.start();

         return true;
      
      } else {
      
         this.valid = false;
         
         return false;
      }
   
   
   }

   /** Return true if the iterator currently has a valid value, false otherwise.*/
   public boolean valid(){
   
      return this.valid;
   }

   /** Advance the iterator to the last valid value in the iteration. (optional operation)*/
   public void end(){
   
      source.activate();
   
      this.numStencilPartitions = stencil.size();
      
      if(this.numStencilPartitions > 0) {
      
         this.currentPartition = this.numStencilPartitions - 1;
      
         this.load(this.currentPartition);
         
         this.valid = true;
      } else {
      
         this.valid = false;
      }
   
   }
   
   
    // From Datablock
   
//    //-------------------- get methods -------------------------------------
//    /** Returns a Values array which encapsulates a 1D array of the data
//     *  values in the block with one entry for every point in the block.
//     *  The type of the Values object is determined by the underlying storage
//     *  type(s) needed. This default implementation returns the Values in the 
//     *  order and type defined by the block. This implementation is expected  
//     *  to be overridden by the child classes for efficiency.
//     */
//    public Values getValues()
//    {
//       Values ret = this.recordDesc.createValues( this.volume() );
//       int    iVal = 0; // index into Values data
//       int    nAttr = this.getNumAttributes();
//       
//       if ( this.getDataOrder() == DataCollection.attributeOrder )
//       {
//          for ( int attr = 0; attr < nAttr; attr++ )
//          {
//             Values aVals = this.getValues( attr );
//             ret.setValues( iVal, aVals );
//             iVal += this.volume();
//          }
//       }
//       else 
//       {
//          Datum dat = this.createDatum();
//          ISIterator iter = new ISIterator( this.bounds );
//          for ( ; iter.valid(); iter.next() )
//          {
//             datum( dat, iter );
//             Values datVals = dat.getValues();
//             ret.setValues( iVal, datVals );
//             iVal += nAttr;
//          }
//       }
//       return ret;
//    }

    //-------------------- set Attribute methods ---------------------------
    /** Set the location specified by the IndexSpaceID to the given datum.*/
   public void setDatum( IndexSpaceID isid, Datum d ) {
   
      new SDBError(SDBError.Recoverable, "Method not implemented." );
   
   }




   // From DataCollection

   /** Given an IndexSpaceID, copy the values of the Datum at that position to the 
    *  argument Datum. 
    */
   public  void datum( Datum dtm, IndexSpaceID did ){
   
      theBlocks[this.currentPartition % 2].datum(dtm, did);
   }

   /** Given an IndexSpaceID and FieldIDMapper, copy the values of the Datum at 
    *  that position to the argument Datum. 
    */
   public  void datum( Datum dtm, IndexSpaceID did, FieldIDMapper mp ){
   
      theBlocks[this.currentPartition % 2].datum(dtm, did, mp);
   }

   /** Reads a subblock defined by srcBounds into the region of the Datablock argument
    defined by dstBounds. */
   public  void subblock( DataBlock theBlock, 
                                  ISBounds dstBounds, ISBounds srcBounds ){
                                  
                                  
      theBlocks[this.currentPartition % 2].subblock(theBlock, dstBounds, srcBounds);
   }
   
   /** Reads a subblock defined by srcBounds into the region of the Datablock argument
    * defined by dstBounds. The FieldIDMapper argument determines the mapping between 
    * datums in this DataBlock and datums in the argument DataBlock. It is legal to 
    * pass a null for the FieldIDMapper argument which means that all attributes are
    * to be extracted.
    */      
   public  void subblock( DataBlock theBlock, 
						         ISBounds dstBounds, ISBounds srcBounds, 
						         FieldIDMapper mp ){
                           
      theBlocks[this.currentPartition % 2].subblock(theBlock, dstBounds, srcBounds, mp);
   }
      


   protected synchronized void load(int index){
   
      if (index < this.numStencilPartitions){
   
         stencil.getIndexedBounds(this.partitionBounds, index);

         source.subblock(theBlocks[index % 2], partitionBounds);
      }
        
   }



   protected class IOThread extends Thread{

      protected DSThreadedPartitionedStencilIterator iter;
      protected int index;
      protected boolean isDone=false;

      IOThread(DSThreadedPartitionedStencilIterator iter, int index){

         super("DSThreadedPartitonedStencilIteratorIOThread");
            
         this.index = index;
         this.iter=iter;
      }

      public void run(){

         iter.load(this.index);
         
         this.isDone = true;
      }

   }

	/** If any IO thread is running, wait for it to terminate.
	 *  
	 */
	void waitOnIOThread(){
	
		if(this.ioThread != null && this.ioThread.isAlive()){
		
			try{
			
				this.ioThread.join();
			} catch(InterruptedException e){
				
				new InternalFaultError(SDBError.Recoverable,"join() was interrupted in waitOnIOThread()");
			}
		}
	}


}
