//-----------------------------------------------------------
// File: DataSourceServer.java
//-----------------------------------------------------------
package edu.unh.sdb.datasource;

import java.rmi.*;
import java.rmi.server.*;
import java.io.*;
import java.net.*;

public class DataSourceServer extends UnicastRemoteObject
                             implements Server
{
   private static final long serialVersionUID = 0; // for serialization inheritance
 /*
  private   String fileName;
  private   RandomAccessFile raFile;
  private   FileChannel fChannel;
  private   ByteBuffer byteBuffer;
  private   byte[] barray;

  private   int bufferSize;
 */

  /* DataServer data memebers
   */
  private DataSource datasource = null;
  private ServerSocket serverSocket = null;
  private Socket       clientSocket = null;
  private DataOutputStream output = null;
  

  DataSourceServer() throws RemoteException
  {
     super();
  /*
  d  this.bufferSize = 100;
    try{
        this.fileName = "simplefile.bin";
        raFile=new RandomAccessFile(fileName,"r");
        fChannel = raFile.getChannel();
        byteBuffer = ByteBuffer.allocateDirect(400);
        barray = new byte[400];
   }
    catch(Exception e)
    {
       System.out.println( e.toString() );
    }
*/
  }

 /* no long needed, old code 
 public DataSourceServer(String fileName) throws RemoteException
 {
    super();
    this.bufferSize = 100;
    try{
        this.fileName = fileName;
        raFile=new RandomAccessFile(fileName,"r");
        fChannel = raFile.getChannel();
        byteBuffer = ByteBuffer.allocateDirect(400);
        barray = new byte[400];
   }
    catch(Exception e)
    {
       System.out.println( e.toString() );
    }
 }
*/
  // test remote object is running
  public int sum(int a,int b) throws RemoteException
  {
     return a + b;
  }

  /** reset and allocate i/o buffer */
  // testing code, no longer needed
/*  public void setBufferSize( int size)
  {
     this.bufferSize = size;
     byteBuffer = ByteBuffer.allocateDirect( this.bufferSize);
     barray = new byte[this.bufferSize];
  }


  public byte[] read(long fileOffset, int queryBufferSize ) throws RemoteException
  {
   try{
      if(this.bufferSize != queryBufferSize)
      {
        byteBuffer = ByteBuffer.allocateDirect(queryBufferSize);
        barray = new byte[queryBufferSize];
      }
     
     System.out.println("file pointer: "+  raFile.getFilePointer());
     if( fileOffset != ( raFile.getFilePointer()) )
        raFile.seek(fileOffset);
     byteBuffer.clear();
     fChannel.read(byteBuffer);
     byteBuffer.clear();
     byteBuffer.get(barray);
 
//-------- test code 
         ByteArrayInputStream input = new ByteArrayInputStream(barray); 
          for( int i =0 ; i<12; i++)
          System.out.println(" the int in the buffer :" + input.read());
//-------- test code 
   }
  catch(Exception e)
  {
     System.out.println(e.toString() );
  }
     return barray;
  }
*/



  public int setDataSource(String xmlFileName , String dsName) throws RemoteException
  {
     datasource = DataSource.create(dsName, xmlFileName);
     datasource.activate();
     int portNumber = 1700;
     try 
      {
         serverSocket = new ServerSocket(portNumber);
      } 
     catch (IOException e) {
          System.out.println("Could not listen on port: "+ portNumber );
          System.exit(-1);
      }
      ListenServer listen = new ListenServer();
      listen.start();

     return portNumber; 
  }

/*
  public void initServer() throws RemoteException
  {
      ListenServer listen = new ListenServer();
      listen.start();
  }
*/


  public void subblock(ISBounds srcBounds) throws RemoteException
  {

    try 
    {
         byte[] byteArray = new byte[srcBounds.volume() * this.datasource.getRecordDescriptor().byteSize()];

         clientSocket.setSendBufferSize( byteArray.length );

         ((PointOrderBFDS)datasource).rsubblock(byteArray, srcBounds);

         //System.out.println(" r block is finished " );
         //System.out.println(" subblock byte size " + byteArray.length );
         //System.out.println(" the socket buffer size " + clientSocket.getSendBufferSize() );
         //System.out.println("is socket output open" + clientSocket.isOutputShutdown() );
         //System.out.println(" query bounds is :" + srcBounds );
         //System.out.println(" available bytes 
         output.write(byteArray);
         //output.write(move);

         //System.out.println(" &&&&&&&&&&&&&&&  DataSource Server finishing writing data into a socket" );
      } 
     catch (IOException e) {
          System.out.println("DataSourceServer.subblock" + e.toString() );
      }

      // ---------- correctness test code -------------------------------------------
      //BasicBlock theBlock = new BasicBlock( srcBounds,datasource.getRecordDescriptor() );
      //datasource.subblock(theBlock, theBlock.getBounds(), srcBounds);
      //System.out.println( theBlock);
  }


  private class ListenServer extends Thread {

     ListenServer()
     {
        super();
     }
     public void  run()
     {
        try
        {
           while(true){
               clientSocket =  serverSocket.accept();
               output = new DataOutputStream( clientSocket.getOutputStream());
               System.out.println("socket sending buffer size :"+ clientSocket.getSendBufferSize() );
           }
        }
        catch (IOException e) {
            System.out.println("Accept failed: 1700");
            System.exit(-1);
        }

     }
  }

  public static void main(String args[])
  {
    try
      {
        //set the security manager
        System.setSecurityManager(new RMISecurityManager());

        //create a local instance of the object
        DataSourceServer Server = new DataSourceServer();
        //SDBFileServer Server = new SDBFileServer();

        //put the local instance in the registry
        Naming.rebind("//zheng.cs.unh.edu/SAMPLE-SERVER" , Server);

        System.out.println("Server waiting.....");
      }
    catch (java.net.MalformedURLException me)
      {
         System.out.println("Malformed URL: " + me.toString());
      }

    catch (RemoteException re)
      {
         System.out.println("Remote exception: " + re.toString());
      }

  }
}

