/*
    KDNode.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    Programmer: LI YE
*/
/* --------------------- Edit history as of 12/10/05 ------------------------
 * 12/12/05 rdb: Deleted KdNode()
 *               Added maxChildren() method
 * 12/10/05 rdb: Added copy constructor and copy() method
 */
                                                                               
/**
 * The KDNode class develop a node structure for a K-d tree.
 * It is extended from the ARRSInternalNode class.
 */

package edu.unh.sdb.datasource;

//import java.io.*;

//import edu.unh.sdb.common.*;

public class KDNode extends ARRSInternalNode 
{
   /** Constructor takes a single ISbounds */
   public KDNode( ISBounds bounds )
   {
      super( bounds );
   }

   /** Constructor takes a ISbounds and a CellIndexable */
   public KDNode( ISBounds bounds, CellIndexable cellSource )
   {
      super( bounds, cellSource );
   }
   /** Copy constructor  */
   public KDNode( KDNode src )
   {
      super( src );
   }
   
   /** copy method creates references to all components, not copies.
    * 
    */
   public ARRSNode copy()
   {
      return new KDNode( this );
   } 
   
   /** return maximum number child nodes (always 2 for kd-tree) */
   public int maxChildren()
   {
      return 2;
   }
}
  
