/*
    ARRSNTreeNode.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    Programmer: LI YE
*/
 
/* --------------------- Edit history as of 12/10/05 ------------------------
 * 12/12/05 rdb: Deleted NTreeNode()
 *               Added getMaxChildren() abstract method
 * 12/10/05 rdb: Added copy constructor and copy() method
 */

/**
 * The ARRSNTreeNode class develop a node structure for a quad tree.
 * It is extended from the ARRSInternalfNode class.
 */
                                                                               
package edu.unh.sdb.datasource;

//import java.io.*;

//import edu.unh.sdb.common.*;

public class NTreeNode extends ARRSInternalNode 
{
   protected int maxChildren;
   
   /** Constructor takes a single ISbounds */
   public NTreeNode( ISBounds bounds )
   {
      this( bounds, (CellIndexable) null );
   }

   /** Constructor takes a ISbounds and a CellIndexable*/
   public NTreeNode( ISBounds bounds, CellIndexable cellSource )
   {
      super( bounds, cellSource );
      maxChildren = 1 << bounds.dim();  // 2^d is max # children
   }

   /** Copy constructor  */
   public NTreeNode( NTreeNode src )
   {
      super( src );
      maxChildren = src.maxChildren;
   }
   
   /** return # allowed children */
   public int maxChildren()
   {
      return this.maxChildren;
   }
   
   /** copy method creates references to all components, not copies.
    * 
    */
   public ARRSNode copy()
   {
      return new NTreeNode( this );
   }                                                                                
}
  
