
/* 
    OverlapBlockManager.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824

    Programmer: Li Ye
*/
//------------------- Edit history --------------------------------------
// 10/21/05 rdb: removed unused variables
//-----------------------------------------------------------------------

/** OverlapBlockManager is mainly used by BlockedDatasource with overlap. 
*/

package edu.unh.sdb.datasource;

import edu.unh.sdb.common.FieldIDMapper;

//import edu.unh.sdb.common.*;
//import java.io.*;

public class OverlapBlockManager extends BlockManager {

    /** Construct a OverlapBlockManager from a array of ComponentInfo */
    public OverlapBlockManager (ComponentInfo[] cinfo ){
       super(cinfo);
    }
    

    /** Reads a subblock defined by srcBounds into the region of the Datablock 
      * argument defined by dstBounds. The FieldIDMapper argument determines 
      * the mapping between datums in the datasource and datums in the 
      * DataBlock. 
    */    
    public void subblock(DataBlock theBlock, ISBounds dstBounds, 
                         ISBounds srcBounds, FieldIDMapper mp) 
    {
       ISIDMapper SrcToDst = new ISIDMapper(srcBounds,dstBounds);
       int i;
       ISBounds isb1,isb2;
       int length = this.components.length;
        
       for (i=0;i<length;i++) {
          isb2 = components[i].getISIDMap().getCompositeExtent();
          isb1 = hasIntersection(srcBounds,isb2);
          if (isb1 != null) {
             if (fmpFlags[i]) {  // if the componentInfo has Field subset info
                if (mp != null) {
                   FieldIDMapper directMapper = 
                      FieldIDMapper.createCrossMap( mp, this.components[i].getFieldIDMap());
                   this.components[i].getComponent().subblock(theBlock,
                      SrcToDst.toComposite(isb1), 
                      components[i].getISIDMap().toComponent(isb1),
                      directMapper );
                }

                else {
                   this.components[i].getComponent().subblock(theBlock,
                      SrcToDst.toComposite(isb1), 
                      components[i].getISIDMap().toComponent(isb1),
                      this.components[i].getFieldIDMap());
                }
             }

             else{
                if (mp != null) {
                   this.components[i].getComponent().subblock( theBlock,
                   SrcToDst.toComposite(isb1), 
                   components[i].getISIDMap().toComponent(isb1), mp );
                }
                else {
                   this.components[i].getComponent().subblock( theBlock,
                   SrcToDst.toComposite(isb1), 
                   components[i].getISIDMap().toComponent(isb1));
                }
             }
          }
       } 

       return ;
    }

}
