/*
    RectCellBlock.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    
    -------------------- Edit history as of 01/26/05 ---------------------------
    01/26/05 rdb: moved size method from ARRCellBlock (where it returned -1) to here
                      and have it return volume -- should be cell volume, but for
                      now it is point volume.
*/

/**
 * The RectCellBlock class provides an interface to access blocks of cell data
 * in a rectilinear cell space.
 */
                                                                                
package edu.unh.sdb.datasource;
                                                                                
import edu.unh.sdb.common.*;
//import java.io.*;

public abstract class RectCellBlock extends CellBlock {

    /** Construct a RectCellBlock without arguments */
    public RectCellBlock()
    {
       super();
    }

    /** Construct a RectCellBlock with the given bounds, axis axisOrdering and
      * RecordDescriptor. The bounds will be moved to the origin.
      */
    public RectCellBlock(ISBounds isb, AxisOrdering ordering,
                     RecordDescriptor recordDesc)
    {
       super(isb, ordering, recordDesc);
    }
                                                                                
    /** Construct a RectCellBlock with the given bounds and number of 
      * attributes 
      */
    public RectCellBlock(ISBounds isb, RecordDescriptor recordDesc)
    {
       super(isb, recordDesc);
    }
                                                                                
    /** Construct a RectCellBlock from a given DataBlock */
    public RectCellBlock(DataBlock b)
    {
       super(b);
    }
    
    /**
     * Size of the CellBlock 
     * The size is the size of the volume it represents in points. 
     * 
     * @TODO should probably be cells, not points.
     */
    public int volume()
    {
       return this.bounds.volume();
    }
    /**
     * @deprecated use volume() instead
     * Size of the CellBlock 
     * The size is the size of the volume it represents in points. 
     */
    public int size()
    {
       return volume();
    }
}
                                                                                
                                                                                
