/*
  RectilinearCell.java
  Copyright 2004 University of New Hampshire
  Durham, NH 03824
  Programmer: LI YE
*/
                                                                                
/**
 * The RectilinearCell class provides an interface to view the data of a 
 * rectilinear cell space with N-dimensionality. It is extended from
 * the Cell class.
 */
                                                                                

package edu.unh.sdb.datasource;
                                                                                
//import java.io.*;
//import edu.unh.sdb.common.*;
                                                                                
public abstract class RectilinearCell extends Cell{

   protected ISBounds baseBounds;

   /** Constructor without arguments */ 
   public RectilinearCell()
   {
      super();
   }
  
   /** Constructor takes a single CellID */
   public RectilinearCell(CellID cellid) 
   { 
      super(cellid);
   }

   /** Constructor takes the specified CellID and the dimensionality */
   public RectilinearCell(CellID cellid, int dim) 
   { 
      super(cellid, dim);
   }

   /** Constructor takes the specified CellID and the base bounds */
   public RectilinearCell(CellID cellid, ISBounds bounds) 
   { 
      super(cellid, bounds.dim());
      this.baseBounds = bounds;
   }

   /** Set the base bounds of a cell */
   public void setBaseBounds(ISBounds bounds)
   {
      this.baseBounds = bounds;
   }

   /** Get the base bounds of a cell */
   public ISBounds getBaseBounds() 
   { 
      return this.baseBounds;
   }
}
