/* 
	Approximator.java
	Copyright 2000 University of New Hampshire
	Durham, NH 03824
*/

package edu.unh.sdb.lattice; 

import edu.unh.sdb.common.*;

/** The Approximator class implements an approximating function used
 *  by the lattice to compute data values for domain locations that do not
 *  necessarily correspond to a sample point.
 *
 */
abstract public class Approximator{
	

    public Approximator(){
	

    }
        
    public abstract Datum approximate(Cell c, Point p);
    public abstract Datum approximate(Cell c, Point p, RecordSpec s);
	
    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }

    
    
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){
    
        return new String(indent+"Approximator:");
    }

}






