//
//  TriangleCellIterator.java
//  Unstructured
//
//  Created by Philip Rhodes on Sun Sep 14 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
//


package edu.unh.sdb.lattice;

import edu.unh.sdb.datasource.*;
//import java.io.*;

public class TriangleCellIterator extends TriangleCell {

	private SplitCellGroupGrid cellGrid;
	private ISIterator partitionID;
	private int index;
	//private TriangleCell theCell;
	private CellID cellID;
	private boolean valid;

	public TriangleCellIterator(Lattice l){
	
		//super(l.getNumAttributes(), l.getGeometryDim());
		
		super(1, l.getGeometryDim());
	
		this.cellGrid=(SplitCellGroupGrid)((UnstructuredTopology)l.getTopology()).getCellGroupGrid();
		
		
		this.partitionID=new ISIterator(this.cellGrid.getGridISBounds());
		
		
		this.cellID=new CellID(this.partitionID, 0);
		
		this.init();
	}
	
	public void init(){
	
		this.valid=true;
		this.partitionID.init();
		this.index=-1;
		this.next();
	}
	
public CellID getCellID(){

	return this.cellID;
}	

	
	
	
	public void next(){
	
		boolean done=false;
	
		do {
		
			try{
			
				this.cellID.incrementIndex();
				
				this.cellGrid.getOwnedCell(this, this.cellID);
				
				done=true;
				
			} catch (ArrayIndexOutOfBoundsException e){
			
				this.partitionID.next();
				
				if (this.partitionID.valid()){
				
					this.index=-1;  // Will be incremented to 0 at top of loop
					this.cellID.assign(this.partitionID, this.index);
 
				} else {
				
					this.valid=false;
				}
			}
			
		} while(this.valid && !done);
	
	}
	
	public boolean valid(){
	
		return this.valid;
	}

    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){

        StringBuffer result=new StringBuffer(indent+"TriangleCellIterator: ");
        result.append(super.toString(""));
        
        return new String(result);

	}
}
