//
//  WriteableInCoreArrayCellGroup.java
//  Unstructured
//
//  Created by Philip Rhodes on Tue Sep 02 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
//
//----------------- edit history ----------------------------------------
// 06/06/08 rdb: Made ArrayList generic

package edu.unh.sdb.lattice;

import edu.unh.sdb.common.*;
import edu.unh.sdb.datasource.*;
import java.util.*;

public class WriteableInCoreArrayCellGroup extends CellGroup{

	protected ArrayList<Integer> cellList;

	//public WriteableInCoreArrayCellGroup(GBounds bounds, int [] vIndices, float [] coords, float[] data, int numAttributes){
	
	public WriteableInCoreArrayCellGroup(GBounds bounds){
	
		super(bounds);
/*	
		this.vIndices=vIndices;
		this.coords=coords;
		this.data=data;
		this.numAttributes=numAttributes;
*/		
		this.cellList=new ArrayList<Integer>(32);
	}
	
	
	public boolean register(TriangleCell c, int cellIndex){

		if(c.intersects(this.bounds)){
		
			this.cellList.add(new Integer(cellIndex));
			return true;
		}
		return false;
    }

    public Cell findEnclosingCell(Point p){
   
		new InternalFaultError(SDBError.Recoverable, "Method not implemented.");
        return null;
    }
    
	public final int getNumCells(){
	
		return this.cellList.size();
	}
	
	public void write( OneDDataSink ds ){
	
		int n=this.cellList.size();
		Datum datum=new FloatDatum(1);
		
		datum.setFloat(0, n); 
		ds.write(datum);
		
		for( int i=0; i<n; i++ ){

			datum.setFloat(0, this.cellList.get(i).intValue());
			ds.write(datum);
		}
	}
	
	void dump(int [] vIndices, float [] coordFloats, float [] dataFloats, int numDataAttributes,
						int dimensionality) {
					
		int n=this.cellList.size();
		TriangleCell c;
		
		for( int i=0; i<n; i++){
			
			c=new TriangleCell(vIndices, coordFloats, dataFloats, 
					numDataAttributes, dimensionality,
					this.cellList.get(i).intValue());

			System.out.println(c);
		}
	}
}
