package edu.unh.sdb.remote;
import java.io.*;
import java.net.*;

public class TCPSender extends Sender
{
	ServerSocket ssock;
  Socket connectionSocket;
  DataOutputStream s_out;
  
	//the client ip is used to make sure the connected client is the right one
	public TCPSender()
	{
		clientIP = null;
		serverDataPort = 0;
		busy = false;
		ssock = null;
		connectionSocket = null;
		s_out = null;
	}
	
	public void freeResource(){
		try{
	  	if(s_out!=null) s_out.close();
	    if(connectionSocket!=null) connectionSocket.close();
	    if(ssock!=null) ssock.close();
	  }catch(Exception e){
	  	System.out.println("Exception while closing server side sockets.");
	  	System.exit(1);
	  }
	}
	
	public void AcceptConnect(){
      try{
       	  //System.out.println("TCP Sender Accepting Connect");
          ssock = new ServerSocket(serverDataPort);
       	  //System.out.println("TCP DataSender ServerSocket created");
          connectionSocket = null;
          while(true){
          	 //System.out.println("TCP DataSender is waiting for request from "+clientIP+" at port "+ssock.getLocalPort());
             connectionSocket = ssock.accept();
             //if(connectionSocket.getInetAddress().getHostAddress().equalsIgnoreCase(clientIP)){
             if(connectionSocket.getInetAddress().getHostAddress().equalsIgnoreCase(clientIP) || connectionSocket.getInetAddress().getHostName().equalsIgnoreCase(clientIP)){
             //if(connectionSocket.getInetAddress().getHostName().equalsIgnoreCase(clientIP)){
				  //System.out.println("Request received from "+connectionSocket.getInetAddress().getHostName()+" - "+connectionSocket.getInetAddress().getHostAddress());
                  break;//picks up the client address and assigns to "ip".
             }
       	  	 //System.out.println("Request received from "+connectionSocket.getInetAddress().getHostName());
       	  	 //System.out.println("But not the right requester!");
             connectionSocket = null;
          }
       	  //System.out.println("Request received from "+connectionSocket.getInetAddress().getHostName()+" - "+connectionSocket.getInetAddress().getHostAddress());
          
         	s_out = new DataOutputStream(connectionSocket.getOutputStream());

      }catch(IOException ioe){
         System.out.println("Socket IO exception" + ioe.toString());	
         freeResource();
         System.exit(1);
      }
	}
	
	//The logic to tell client about size is left to the app
	public int SendData(byte buf[], int size){
			if(s_out==null) AcceptConnect();
			//System.out.println("sending data of " + size + " bytes");
      try{
          s_out.write(buf, 0, size);
          s_out.flush();
          return 0;
      }catch(IOException ioe){
         System.out.println("Socket IO exception" + ioe.toString());	
         freeResource();
         return 1;
      }
	}
}
