/*
 * UDPReceiver.java
 * ----------------------- edit history -------------------------------
 * 06/06/09 rdb: Changed references to static variables and methods to be static 
 *                 references (using class name, rather than instance variable).
 *               Commented out many variables that are never used; some are 
 *                 obviously for future implementation, some were for testing
 */
package edu.unh.sdb.remote;

//import java.nio.*;
//import java.io.*;
import java.net.*;

import edu.unh.sdb.datasource.*;
//import edu.unh.sdb.common.*;
import java.util.StringTokenizer;

public class UDPReceiver extends DataReceiver
{
	//private byte[] bArray;
	
	//private ByteBuffer datumBuffer;
	//private FloatBuffer fdatumBuffer;
	//private Socket      dataSocket;
	//private DataInputStream input;
	
	//private byte[] tmpBuffer;
	//private int tmpBufferSize;
	
	private String ctrlMsg = null;
	
	//for performance tests
	//private long t1 =0;
	//private long t2 =0;
	//private long time =0;
	
	   //port numbers.
	public static int serverControlPort = 2223;//TCP Control source/sink port.
	//public static int serverHelloPort = 6789;//Server Hello Port.
	public static int serverAlarmPort = 3333;//TCP Server Alarm port for abnormal exit.
	public static int clientDataPort = 5555;//UDP Data sink port.
	public static int clientControlPort = 4445;//TCP Control sink/source port.
	 
	 private RemoteMessenger rm;
	//sockets used.
	public static ServerSocket welcomeSocket;
	public static DatagramSocket ds;
	public static InetAddress ip;
	
	//some global variables used.
	public static int fileSize;//size of file being transferred.
	public static int buffer_size;//data packet size.
	public static int packetSize;//holds the packet size.
	public static int times = 0;//variable used to store the number of expected packets.
	public static int rempart = 0;//variable to hold the size of last partial packet, if any.
	public static int number_packets = 0;//variable to hold number of packets received.
	public static int[] lostPacketArray = new int[100000];//array to store missing packet sequence numbers.
	public static int lostPacketCounter;//variable to hold a count of lost packets.
	public static String missedPacket;//variable to store missed packet integers as a string.
	
	public static int globalVal;//variable used by the alarm thread to check the client activity.
	public static long start, end;//variables to hold start & end times of file transfer.
	public static int statusFlag = 0;//flag that tells which stage of main thread is running.
	
	public static byte[] dstByteArray;//byte array into which the requested subblock will get into.
	public static int[] lower, upper;//integer arrays used for storing the bounds.
	public static int[] lowerSpaceArray, upperSpaceArray;//integer arrays used for storing the space bounds.
	public static int[] lowerPartitioningArray, upperPartitioningArray;//arrays for storing partitioning bounds.
	public static String bounds;//variable used to hold a string of lower & upper bounds.
	
	
	private boolean sentStencilConstructorInfo = false;
	
	static int[] lostRetranPacketArray;//array to store missing retransmitted packet sequence numbers.
	static byte a[]= new byte[4];//packet seq_num decoding array.
	
	//the client ip is used to make sure the connected client is the right one
	public UDPReceiver()
	{
		serverIP 				= null;
		serverDataPort	= 0;
		rm = null;
		welcomeSocket = null;
		missedPacket = "";
	}
	
	public void setRemoteMessenger(RemoteMessenger rm){
		this.rm = rm;
	}
	
	public void setClientCtrlSocket(ServerSocket ssock){
      UDPReceiver.welcomeSocket = ssock;
	}
	
	public void freeResource(){
		
	}
	
	public void setBufSize(int size){
		UDPReceiver.buffer_size = size;
	}
		
	/** read an array of bytes from the socket. It makes sure the number of bytes being read ==
	*  the length. The function will block until length number of bytes being read
	*/
	private void readBytes(byte[] data, int length )
	{
		ReceiveData(data, length);
	}
	
	/** read an array of floats from the socket. It reads bytes from the socket buffer
	and put it into a small temp byte buffer with its size as a multiple of 4. Then
	we convert the bytes into floats and copy them into dst float array.
	This function will block until the dstArray is full
	*/
	private void readFloats(float[] dstArray)
	{
		//int size = dstArray.length;
		int byteSize = dstArray.length * 4;
		byte tmpBuffer[] = new byte[byteSize];
		readBytes(tmpBuffer, byteSize);      
		GraniteRemoteClient.bytesToFloats( dstArray, tmpBuffer, byteSize);
	}
	
	public void SendMissingPacketInfo(String missedPacket){
		System.out.println("Missing packet info on client side: "+missedPacket);
		rm.PassivelySendControlInfo(welcomeSocket, missedPacket, serverIP);//control packet to let server know about missing packets.
	}
	
	/** Finds the integer value of 32 bit binary string.
	*/
	public static int Seqnum_Decoder(byte a[])
	{
	   	return((a[0] << 24) & 0xFF000000 |(a[1] << 16) & 0x00FF0000 | (a[2] << 8) & 0x0000FF00 | a[3] & 0x000000FF);
	}
		
	public int ReceiveData(byte dstByteArray[], int fileSize) //throws Exception
	{
	   byte a[] = new byte[4];//packet seq_num decoding array.
	   int loop_counter = 0;
	   //InterPacketDelay t = new InterPacketDelay();//object used to set interpacket delay.
	
	   try
	   {
		  while(true)
		  {
			 //a nonzero positive value indicates the packet size being used for file transfer.
	
			 start = System.currentTimeMillis();//start of transfer.
	
			 if(buffer_size != -1)//tcp control information "-1" means end of transfer.
			 {
				packetSize = buffer_size;//making a copy of packet size into packetSize.
							
				//logic to calculate the number of packets & store it in "times" variable.
				times = fileSize/buffer_size;
				rempart = fileSize % buffer_size;//size of last partial packet, if any.
				//System.out.println("Rempart: " + rempart);
				if(rempart != 0)
				{
				   times += 1;
				}
	
				//System.out.println("Times: " + times);
				////System.out.println("**********************************");
				////System.out.println("Packet Size: " + buffer_size);
				byte[] receiveData = new byte[buffer_size+4];//array to receive packets from server.
	
				//declaring the length of dstByteArray.
				if(times != 0 && rempart != 0)
				{
				   dstByteArray = new byte[((times-1) * buffer_size) + rempart];
				}
				else if(times != 0 && rempart == 0)
				{
				   dstByteArray = new byte[times * buffer_size];
				}
				else
				{
				   dstByteArray = new byte[rempart];
				}
	
				int currentSeqNum=0;//variable to store next expected packet sequence number.
				missedPacket = "";//variable to store missed packet integers as a string.
				lostPacketCounter = 0;//variable to count number of lost packets.
				//t.wait(10);//inducing a wait to synchronize client & server.
				
	//            System.out.println("Calling  ServerToClientControlInfo(Ok) in ReceiveData().");
	//            ServerToClientControlInfo();//tcp connection for making the server wait for sometime so
	//                                 //that client can initialize itself for the file transfer.
	//            System.out.println("Calling  ServerToClientControlInfo(Ok) in ReceiveData().");                    
									 
				//System.out.println("Hey there client is synchronized with the server.");
				while(loop_counter != times)//Client expects to be running this loop "times" times.
				{
				   try
				   {
					  DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
					  ds.setSoTimeout(20000);
					  ds.receive(receivePacket);
					  //String p = new String(receivePacket.getData());
	
					  //sequence number printing.
					  //updating the loop counter to the latest UDP packet seq number.
					  a[0] = receiveData[buffer_size];
					  a[1] = receiveData[buffer_size+1];
					  a[2] = receiveData[buffer_size+2];
					  a[3] = receiveData[buffer_size+3];
					  loop_counter = Seqnum_Decoder(a);//recording the packet sequence number into variable "loop_counter".
	
					  //******************************
					  globalVal = loop_counter;//alarm thread keeps watching "globalVal" for activity.
					  //******************************
	
					  //logic for figuring out missing packet sequence numbers.
					  if(currentSeqNum == loop_counter)//expected packet seq number has arrived.
					  {
						 currentSeqNum++;//next expected packet sequence number.
					  }
					  else if(currentSeqNum < loop_counter)//forward jump in the arrived packet seq number.
					  {
						 //logic to store missing packet sequence numbers.
						 for(int l=currentSeqNum;l<loop_counter;l++)
						 {
							lostPacketArray[lostPacketCounter] = l;
							lostPacketCounter++;
						 }
						 currentSeqNum = loop_counter + 1;//next expected packet sequence number.
					  }
					  else//backward jump in the arrived packet sequence number.
					  {
						 ////System.out.println("Hey there, this is an out of order packet!!");
						 //search thru the lost packet list & delete this entry.
						 for(int i=0;i<lostPacketCounter;i++)
						 {
							if(lostPacketArray[i] == loop_counter)
							{
							   for(int j=i;j<lostPacketCounter-1;j++)
							   {
								  lostPacketArray[j] = lostPacketArray[j+1];//left shift all the other lost packet entries.
							   }
							   lostPacketCounter--;//decrementing by one position for new lost packet entry.
							   break;
							}
						 }
					  }
	
					  number_packets++;//variable to store number of packets received.
	
					  //logic to store the packet into "dstByteArray" array.
					  if(loop_counter != times-1)
					  {
						 System.arraycopy(receiveData,0,dstByteArray,loop_counter * buffer_size,buffer_size);
					  }
					  else
					  {
						 if(rempart != 0)//case of last partial packet.
						 {
							System.arraycopy(receiveData,0,dstByteArray,loop_counter * buffer_size,rempart);
						 }
						 else//case of last full packet.
						 {
							System.arraycopy(receiveData,0,dstByteArray,loop_counter * buffer_size,buffer_size);
						 }
					  }
					  loop_counter++;//variable to count the number of times this loop executes.
				   }//end of try.
				   catch(SocketException e)
				   {
					  ////System.out.println("Lost last packet(s) case.");
					  //System.out.println("Last packet received: " + globalVal);
					  //System.out.println("Lost packet counter: " + lostPacketCounter);
					  break;
				   }//end of catch for SocketException e.
				}//end of inner while.
	
				statusFlag = 1;//first receive loop executed successfully.
	
				if(lostPacketCounter > 0)
				{
				   //constructing a comma delimited string of missed packet sequence numbers to notify server.
				   for(int k=0;k<lostPacketCounter;k++)
				   {
					  if(k != lostPacketCounter-1)
					  {
						 missedPacket += lostPacketArray[k] + ",";
					  }
					  else
					  {
						 missedPacket += lostPacketArray[k];
					  }
				   }
				   //System.out.println("Missed packet string: " + missedPacket);
				}
	
					//System.out.println("Calling ClientToServerControlInfo(missedPacket) in ReceiveData()");
					//rm.SendControlInfo(welcomeSocket, missedPacket);//control packet to let server know about missing packets.
					SendMissingPacketInfo(missedPacket);
					//System.out.println("Back From ClientToServerControlInfo(missedPacket) in ReceiveData()");
				
				//starting PacketRetransmission logic if missedPacket string is not null.
				if(!missedPacket.equals(""))
				{
				   PacketRetransmission(missedPacket);
				}
				else
				{
				   ////System.out.println("No missing packets.");
				}
	
				////System.out.println("Number of packets received: " + number_packets);
	
				end = System.currentTimeMillis();//end of transfer.
				////System.out.println("%%% Transfer_Time " + (end - start));
	//            System.out.println("Calling ClientToServerControlInfo(Time: ) in ReceiveData()");
	//            ClientToServerControlInfo("Time: " + (end-start));//control info to report server of total transfer time.
	//            System.out.println("Calling ClientToServerControlInfo(Time: ) in ReceiveData()");
				////System.out.println("File size transferred: " + (double) (fileSize)/1000 + " KB");
	
				/*////checking to see if there are any lost packets.
				for(int i=0;i<times;i++)
				{
				   flag = 0;
				   globalVal = i;//activity variable for client alarm thread.
				   for(int j=0;j<buffer_size;j++)
				   {
					  if(dataStore[i][j] != 0)
					  {
						 flag = 1;
						 break;
					  }
				   }
				   if(flag == 0)
				   {
					  System.out.println("Packet Loss.");
				   }
				}
				*/
	
				////System.out.println("**********************************");
				////System.out.println();
			 }//end of if.
			 else
			 {
				break;
			 }//end of else.
		  }//end of outer while.
	
		  number_packets = 0;//reinitializing number_packets variable after the transfer.
	   }//end of outer try.
	   
	   catch(SocketTimeoutException e){
	   
		  System.out.println("Socket Time Out in ReceiveData()");
		  System.exit(1);
	   }
	   
	   catch ( Exception exception )
	   {
		  //exception.printStackTrace();
		  try
		  {
			 //special logic to handle the lost last packet(s) case.
			 //System.out.println("******Lost last packet(s) case.******");
			 //System.out.println("Last packet received: " + globalVal);
			 //System.out.println("Lost packet counter: " + lostPacketCounter);
	
			 //logic to store missing packet sequence numbers.
			 for(int l=globalVal+1;l<times;l++)
			 {
				lostPacketArray[lostPacketCounter] = l;
				lostPacketCounter++;
			 }
	
			 if(lostPacketCounter > 0)
			 {
				for(int k=0;k<lostPacketCounter;k++)
				{
				   if(k != lostPacketCounter-1)
				   {
					  missedPacket += lostPacketArray[k] + ",";
				   }
				   else
				   {
					  missedPacket += lostPacketArray[k];
				   }
				}
				//System.out.println("Missed packet string: " + missedPacket);
			 }
	
			 //rm.SendControlInfo(welcomeSocket,missedPacket);//control packet to let server know about missing packets.
	 		 SendMissingPacketInfo(missedPacket);
			 //starting PacketRetransmission logic if missedPacket string is not null.
			 if(!missedPacket.equals(""))
			 {
				PacketRetransmission(missedPacket);
			 }
			 else
			 {
				////System.out.println("No missing packets.");
			 }
	
			 ////System.out.println("Number of packets received: " + number_packets);
	
			 end = System.currentTimeMillis();//end of transfer.
	
			 ctrlMsg = rm.ActivelyReceiveControlInfo(serverIP, serverControlPort);//tcp connection to read packet size.
	
		  }
		  catch(Exception ex)
		  {
			 ex.printStackTrace();
		  }//end of catch for Exception ex.
		  //number_packets = 0;
		}//end of catch for Exception exception.
		return 0;
	}
	
	/** Interpacket delay parameter setter.
	*/
	public static class InterPacketDelay extends Thread
	{
	   public static void wait(int n)
	   {
		  try
		  {
			 Thread.sleep(n);
		  }
		  catch(InterruptedException exception)
		  {
			 exception.printStackTrace();
		  }
	   }
	}
	
	
	
	/** Logic to receive packet retransmissions.
	*/
	public void PacketRetransmission(String s) //throws Exception
	{
	
		//System.out.println("Calling PacketRetransmission()");
	
	   int lostRetranPacketCounter = 0,loop_counter = 0,packetCounter=0,currentSeqNum,packetSeqnum=0;
	   int startPos=0,endPos=0,tokenCounter=0;//"tokenCounter" holds the number of missed packets requiring to be retransmitted.
	   StringTokenizer st = new StringTokenizer(s,",");//tokenizing the missedPacket string with ",".
	   StringTokenizer st1 = new StringTokenizer(s,",");//tokenizing the missedPacket string with ",".
	   //InterPacketDelay t = new InterPacketDelay();//object used to set interpacket delay.
	   String missedRetranPacket = "";//variable to store missed retransmitted packet integers as a string.
	   //logic to find out the number of missing packets.
	   while(st.hasMoreTokens())
	   {
		  st.nextToken();
		  tokenCounter++;
	   }
	
	   //System.out.println("Token Counter: " + tokenCounter);
	
	   int[] lostPackets = new int[tokenCounter];//array to hold the lost packet numbers for retransmission logic below.
	   //populating the lostPackets array with lost packet seq numbers.
	   int x=0;
	   while(st1.hasMoreTokens())
	   {
		  lostPackets[x] = Integer.parseInt(st1.nextToken());
		  x++;
	   }
	
	   /*
	   //checking the contents of lostPackets array.
	   for(int i=0;i<x;i++)
	   {
		  System.out.println(lostPackets[i]);
	   }
	   */
	
	//   int[] lostRetranPacketArray = new int[100000];//array to store missing retransmitted packet sequence numbers.
	
	   byte[] receiveData = new byte[buffer_size+4];//array to receive packets from server.
	//   byte a[] = new byte[4];//packet seq_num decoding array.
	
	   //System.out.println("# of missed packets: " + x);
	
	   try
	   {
		  //System.out.println("Socket Timeout: " + ds.getSoTimeout());
		  //t.wait(50);
		  //ServerToClientControlInfo();//tcp connection for making the server wait for sometime so
							   //that client can initialize itself for the file transfer.
		  while(loop_counter != tokenCounter)
		  {
			 try
			 {
				DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
				ds.setSoTimeout(20000);
				ds.receive(receivePacket);
	
				currentSeqNum = lostPackets[loop_counter];//expected packet sequence number.
	
				//sequence number printing.
				//updating the loop counter to the latest UDP packet seq number.
				a[0] = receiveData[buffer_size];
				a[1] = receiveData[buffer_size+1];
				a[2] = receiveData[buffer_size+2];
				a[3] = receiveData[buffer_size+3];
				packetSeqnum = Seqnum_Decoder(a);//recording the packet sequence number into  variable "packetSeqnum".
	
				//******************************
				globalVal = packetSeqnum;//alarm thread keeps watching "globalVal" for activity.
				//******************************
	
				//System.out.println("Arrived Packet seq no: " + packetSeqnum);
	
				//logic for figuring out missing packet sequence numbers.
				if((currentSeqNum == packetSeqnum) && (packetSeqnum < lostPackets[x-1]))//expected packet seq number has arrived.
				{
				   currentSeqNum = lostPackets[loop_counter+1];
				}
				else if(currentSeqNum < packetSeqnum)//forward jump in the arrived packet seq number.
				{
				   //logic to store missing packet sequence numbers.
				   for(int i=0;i<x;i++)
				   {
					  if(lostPackets[i] == currentSeqNum)
					  {
						 startPos = i;
					  }
					  else if(lostPackets[i] == packetSeqnum)
					  {
						 endPos = i;
					  }
					  else
					  {
						 //do nothing.
					  }
				   }
				   for(int l=startPos;l<endPos;l++)
				   {
					  lostRetranPacketArray[lostRetranPacketCounter] = lostPackets[l];
					  lostRetranPacketCounter++;
				   }
				   loop_counter = endPos;
				   //setting the next expected sequence number to the next in lostPackets array as long as arrived packet is not the last.
				   if(loop_counter != x-1)
				   {
					  currentSeqNum = lostPackets[loop_counter + 1];
				   }
				}
				else if(currentSeqNum == lostPackets[x-1])
				{
				   //case of the last lost packet being received.
				}
				else//backward jump in the arrived packet sequence number.
				{
				   ////System.out.println("Hey there, this is an out of order retransmitted packet!!" + packetSeqnum);
				   //search thru the lost packet list & delete this entry.
				   for(int i=0;i<lostRetranPacketCounter;i++)
				   {
					  if(lostRetranPacketArray[i] == packetSeqnum)
					  {
						 for(int j=i;j<lostRetranPacketCounter-1;j++)
						 {
							lostRetranPacketArray[j] = lostRetranPacketArray[j+1];//left shift all the other lost packet entries.
						 }
						 lostRetranPacketCounter--;//decrementing by one position for new lost packet entry.
						 break;
					  }
				   }
				}
	
				number_packets++;//variable to store number of packets received.
	
				//logic to store the packet into "dataStore" array.
				if(packetSeqnum != times-1)
				{
				   System.arraycopy(receiveData,0,dstByteArray,packetSeqnum * buffer_size,buffer_size);
				}
				else
				{
				   if(rempart != 0)//case of last partial packet.
				   {
					  System.arraycopy(receiveData,0,dstByteArray,packetSeqnum * buffer_size,rempart);
				   }
				   else//case of last full packet.
				   {
					  System.arraycopy(receiveData,0,dstByteArray,packetSeqnum * buffer_size,buffer_size);
				   }
				}
	
				loop_counter++;//variable to count the number of times this loop executes.
				packetCounter++;//local variable to keep track of the number of retransmitted pkts received.
			 }
			 catch(SocketException e)
			 {
				////System.out.println("Lost last packet(s) case.");
				//System.out.println("Last packet received: " + globalVal);
				//System.out.println("Lost packet counter: " + lostPacketCounter);
				break;
			 }
	
		  }//end of while.
	
		  ////System.out.println("Number of retransmissions received: " + packetCounter);
	
		  //logic to handle retransmission of retransmitted packets.
		  for(int k=0;k<lostRetranPacketCounter;k++)
		  {
			 if(k != lostRetranPacketCounter-1)
			 {
				missedRetranPacket += lostRetranPacketArray[k] + ",";
			 }
			 else
			 {
				missedRetranPacket += lostRetranPacketArray[k];
			 }
		  }
		  //t.wait(50);
		  //ServerToClientControlInfo();//tcp connection logic for synchronizing with server.
		  ////System.out.println("Client synchronized with the server.");
		  //rm.SendControlInfo(welcomeSocket, missedRetranPacket);//control packet to let server know about missing retransmitted packets.
		  SendMissingPacketInfo(missedPacket);
		  //starting PacketRetransmission logic if missedRetranPacket string is not null.
		  if(!missedRetranPacket.equals(""))
		  {
			 PacketRetransmission(missedRetranPacket);//requesting a resend if missed packet string is not null.
		  }
		  else
		  {
			 ////System.out.println("No missing packets.");
		  }
	   }//end of try.
	   catch(Exception exception)
	   {
		  try
		  {
			 //logic to handle lost last retransmitted packet(s).
			 ////System.out.println("******Lost last retransmitted packet(s) case.******");
			 for(int i=0;i<x;i++)
			 {
				if(lostPackets[i] == globalVal)
				{
				   startPos = i;
				   break;
				}
			 }
			 for(int l=startPos;l<x;l++)
			 {
				lostRetranPacketArray[lostRetranPacketCounter] = lostPackets[l];
				lostRetranPacketCounter++;
			 }
			 ////System.out.println("Number of retransmissions received: " + packetCounter);
	
			 //logic to handle retransmission of retransmitted packets.
			 for(int k=0;k<lostRetranPacketCounter;k++)
			 {
				if(k != lostRetranPacketCounter-1)
				{
				   missedRetranPacket += lostRetranPacketArray[k] + ",";
				}
				else
				{
				   missedRetranPacket += lostRetranPacketArray[k];
				}
			 }
			 //t.wait(50);
			 //ServerToClientControlInfo();//tcp connection logic for synchronizing with server.
			 ////System.out.println("Client synchronized with the server.");
			 //rm.SendControlInfo(welcomeSocket, missedRetranPacket);//control packet to let server know about missing retransmitted packets.
			 SendMissingPacketInfo(missedPacket);
			 //starting PacketRetransmission logic if missedRetranPacket string is not null.
			 if(!missedRetranPacket.equals(""))
			 {
				PacketRetransmission(missedRetranPacket);//requesting a resend if missed packet string is not null.
			 }
			 else
			 {
				////System.out.println("No missing packets.");
			 }
		  }//end of try.
		  catch(Exception ex)
		  {
			 ex.printStackTrace();
		  }//end of catch for Exception ex.
	   }//end of catch for Exception exception.
	   
	   //System.out.println("Leaving PacketRetransmission");
	}//end of PacketRetransmission.

}