package edu.unh.sdb.remote;
import java.io.IOException;

public class UDTReceiver extends DataReceiver
{
	static{
				System.loadLibrary("UDTReceiver");
				//System.out.println("Native Library UDTReceiver loaded !!!!!");
	}
	
  private static native int nativeReceiveData(byte dstArray[], String ip, int dataPort, int size) throws IOException;
	
	//the client ip is used to make sure the connected client is the right one
	public UDTReceiver()
	{
		serverIP 				= null;
		serverDataPort	= 0;
	}
	
	public void freeResource(){}
	
	//The logic to tell client about size is left to the app
	public synchronized int ReceiveData(byte dst[], int size){
	  int status = 1; //0 means normal return
		try{
         System.out.print("UDTReceiver.ReceiveData: Starting native code ... ");
			status = nativeReceiveData(dst, serverIP, serverDataPort, size);
         System.out.println("done.");
		}catch(IOException e)
		{
			System.out.println("IOException from native code: "+e);
			status = 1; //make sure status is returned as 1 to denote exception
		}
		return status;
	}	
}
