package edu.unh.sdb.remote;
import java.io.IOException;

public class UDTSender extends Sender
{
	static{
				System.loadLibrary("UDTSender");
				//System.out.println("Native Library UDTSender loaded !!!!!");
	}
	
  private static native int nativeSendData(String ip, int dataPort, byte buf[], int size) throws IOException;
	//the client ip is used to make sure the connected client is the right one
	public UDTSender()
	{
		clientIP = null;
		serverDataPort = 0;
		busy = false;
	}
	
	public void freeResource(){
		//nothing to do since the native code will automatically do that
	}
	
	//The logic to tell client about size is left to the app
	public int SendData(byte buf[], int size){
	  int status = 1;
		try{
			System.out.print("UDTSender.SendData: Starting native code ... ");
			status = nativeSendData(clientIP, serverDataPort, buf, size);
			System.out.println("done.");
		}catch(IOException e)
		{
			System.out.println("IOException from JNI: "+e);
			status = 1;
		}
		return status;
	}
}
