package edu.unh.sdb.util.VisitGraniteFramework.GraniteServer;

/*
 * GraniteClient
 * 
 * Created on Jun 6, 2005
 *
 */

//import java.io.*;
import java.io.*;
//import java.nio.*;
//import java.nio.channels.*;
import java.net.*;
//import javax.net.*;
//import edu.unh.sdb.datasource.*;

/**
 * GraniteClient
 *     A Java implementation of a dumb client to test the GraniteServer class.
 * 
 * @author rdb
 *
 */
public class GraniteClient
{
   //---------------- "main" variables -----------------------------   
   private static int       portNumber = 0;
   private static String    inFile     = null;

   // for running standalone, keep a reference to an instance available.
   private static GraniteServer theApp = null;
   
   //
   private static ServerSocket server = null;
   

   /**
    * Construct an instance, args 
    */
   public GraniteClient()
   {
   }

   /**
    *  java GraniteClient [-p portNumber ] inFile
    *             portNumber is socket port
    *             inFile - file of commands to be passed to GraniteServer
    * 
    */
   public static void main( String[] args )
   {
      InetAddress   address = null;
      Socket        client  = null;
      GraniteServer gServer = null;
      
      parseArgs( args );
      try
      {
         address = InetAddress.getLocalHost();
         client  = new Socket( address, portNumber ); 
         gServer = new GraniteServer( client );
         server  = gServer.getServerSocket();         
      }
      catch ( Exception ex )
      {
         System.err.println( "GraniteClient failure: " + ex );
         System.exit( -1 );
      }
      
      // setup ByteBuffer
      //final int maxLineSize = 4096; // make it much larger than we ever expect
      //byte[]     lineBytes   = null;
      //ByteBuffer lineBuf = ByteBuffer.allocate( maxLineSize );
      //ByteBuffer retBuf  = ByteBuffer.allocate( maxLineSize );
      
      // open file
      BufferedReader rdr = null;
      //SocketChannel channel = client.getChannel();
      BufferedReader  inSocket = null;
      PrintWriter     outSocket = null;
      
      String inLine  = null;
      String retLine = null;

      try
      {
         inSocket  = new BufferedReader( new InputStreamReader( client.getInputStream()));
         outSocket = new PrintWriter( client.getOutputStream() );
         inLine = rdr.readLine();
         rdr = new BufferedReader( new InputStreamReader( 
                                       new FileInputStream( inFile )));
         while ( inLine != null )
         {
            //lineBuf.clear();
            System.out.println( "In: " + inLine );
            //lineBytes = line.getBytes();
            //lineBuf.put( lineBytes );
            outSocket.println( inLine );
                       
            //int outCnt = channel.write( lineBuf );
            //System.out.println( "---Bytes written: " + outCnt );
            //if ( outCnt != lineBuf.capacity() )
               //ystem.out.println( "--- short by: " + ( lineBuf.capacity() - outCnt ));
            
            //   read result
            //channel.read( retBuf );
            retLine = inSocket.readLine();
            System.out.println( "Return: " + retLine );
            //
            inLine = rdr.readLine();           
         }         
      }
         catch( Exception e )
         {
            if ( rdr == null )
               System.err.println( "Error: Unable to open file: " + inFile );
            else 
               System.err.println( "IO Error: " + e );
            System.exit( -1 );
         }      
   }

   //----------------- parseArgs( String[] ) -------------------------------
   public static void parseArgs( String argv[] )
   {
      int arg = 0; 
      
      try
      {
      if ( argv[0].equals( "-p" ))
      {
         portNumber = ( new Integer( argv[ ++arg ] )).intValue();
         arg++;
      }
      // check for input file specification on command line
      if ( argv.length > arg )
         inFile = argv[ arg ];
      }
      catch ( Exception ex )
      {
         System.err.println( "Argument error." );
         System.err.println( "Usage: java GraniteClient [-p portNumber] inFile" );
         System.exit( -1 );
      }
   }
}
