#!/bin/bash
UDT_DIST_VERSION="UDT3"
udt_src_dir="../../$UDT_DIST_VERSION/src"
#debug="-g"
debug=""
os=`echo $OSTYPE | cut -c 1-5`

if [ $os == "linux" ]; then

   ##for linux

   g++ ${debug} -c -fPIC -I$udt_src_dir $1.cpp
   g++ ${debug} -shared -fPIC -o lib$1.so -L$udt_src_dir -ludt -lstdc++ -lpthread $1.o

else
   other=`echo $OSTYPE | cut -c 1-6`
   if [ $other == "darwin" ]; then
	   ##for mac osx

      mac_java_header_dir="/System/Library/Frameworks/JavaVM.framework/Versions/1.5.0/Headers/"

      ## echo "    g++ -c -fno-common -I$udt_src_dir -I$mac_java_header_dir $1.cpp"
      ## echo "    g++ -dynamiclib -fno-common -o lib$1.jnilib -L$udt_src_dir -ludt -lstdc++ -lpthread $1.o -framework JavaVM"

      g++ ${debug} -c -fno-common -I$udt_src_dir -I$mac_java_header_dir $1.cpp
      g++ ${debug} -dynamiclib -fno-common -o lib$1.jnilib -L$udt_src_dir -ludt -lstdc++ -lpthread $1.o -framework JavaVM
   else
		echo "!!!!!!!			Linux_MacOSX_BuildLibs.sh 				!!!!!!!!"
		echo "!!!!!!!	Only linux and MacOSX are supported for now.	!!!!!!!!"
   fi

fi
